/**
 *@file 
 *@brief debug 함수들
 *@author 김성태
 *@date 2008-08-13
 */

var TRACE_LEVEL = {
	DEBUG : 0,
	INFO : 1,
	WARN : 2,
    ERROR : 3,
    FATAL : 4
}

var traceLevel = TRACE_LEVEL.DEBUG;

/**
 * @brief		log level 조정
 * @remarks
 * @param		argLevel	: DEBUG, INFO, WARN, ERROR, FATAL
 * @return
 */
function setTraceLevel(argLevel) {
    traceLevel = argLevel;
}

/**
 * @brief		브라우져 확인.
 * @remarks		Maple 브라우져일때 true 리턴
 * @param
 * @return		true	false
 */
function checkMaple() {
	if(navigator.appName == "Maple") {
        return true;
	} else {
        return false;
	}    
}

/**
 * @brief	level별 log print
 * @remarks
 * @param	argMsg : log message	argLevel : log level
 * @return
 */
function TRACE(argMsg, argLevel) {
    var showMsg = "";

    if (checkMaple()) {
        if (argLevel!="" && argLevel>=traceLevel) {
            switch(argLevel) {
                case TRACE_LEVEL.DEBUG:
                    showMsg = "DEBUG ::: ";
                    break;
                case TRACE_LEVEL.INFO:
                    showMsg = "INFO ::: ";
                    break;
                case TRACE_LEVEL.WARN:
                    showMsg = "WARN ::: ";
                    break;
                case TRACE_LEVEL.ERROR:
                    showMsg = "ERROR ::: ";
                    break;
                case TRACE_LEVEL.FATAL:
                    showMsg = "FATAL ::: ";
                    break;
                default:
                    showMsg = "NO OPTION ::: ";
                    break;
            }
            showMsg += argMsg; 
            alert(showMsg);
        } else {
            if (traceLevel == TRACE_LEVEL.DEBUG) {
                alert("DEBUG ::: " + argMsg);
            }
        }
    }
}
