var PopupModule = {
	MAX_MENU_NUM : 1,
	puPrevFocusObj : null,
	callbackFunc : null,
	gPopupInstance : null,
	gPopupTimer : false,
	
	TIMER_SET : 1000,
	TIMER_RESET : 1001,
	loadingTimer : 0,	
	loadingImg : null,
	currentImg : 0
}

/**
 * @brief			팝업을 연다
 * @remarks		지정된 사이즈로 화면 중앙에 팝업을 생성한다.
* @param		requestedMsg		메세지 창에 띄울 문구
* @param		buttonStr0		첫번째 버튼 이름
* @param		buttonStr1		두번째 버튼 이름
* @return		void
*/
PopupModule.openPopup = function (requestedMsg, requestedFunc, requestedTime, buttonStr0, buttonStr1) {
    TRACE("START PopupModule.openPopup()");
	
	if ((requestedMsg != null) && (requestedFunc != null) && (requestedTime != null)) {
		TRACE("openPopup("+requestedMsg+","+requestedTime+")");
		this.callbackFunc = requestedFunc;
		this.setPopupWindow (requestedMsg.length);
		if ((buttonStr0 == null)&&(buttonStr1 == null)) {
			this.createPopupHtml (requestedMsg, 1);
			document.getElementById("UIPopupOneHelpLayer").style.visibility =  "visible";			
        } else if ((buttonStr0 != null) && (buttonStr1 == null)) {
			this.createPopupHtml (requestedMsg, 1, buttonStr0);
			document.getElementById("UIPopupOneHelpLayer").style.visibility =  "visible";
        } else if ((buttonStr0 != null) && (buttonStr1 != null)) {
			this.createPopupHtml (requestedMsg, 2, buttonStr0, buttonStr1);
			document.getElementById("UIPopupTwoHelpLayer").style.visibility =  "visible"; 
        }

		this.popupTimerProcess (this.TIMER_SET, requestedTime);
		this.turnPopup("on");
		document.getElementById("popupButton0").focus();
		if ((buttonStr1 != null)) {
            document.getElementById("popupButton1").style.backgroundImage= "url('img/button_normal.png')";
        }
		TRACE("openPopup("+requestedMsg+","+requestedTime+") Ends.");
	}
    TRACE("END PopupModule.openPopup()");
}

/**
 * @brief			팝업을 연다
 * @remarks		지정된 사이즈로 화면 중앙에 팝업을 생성한다.
* @param		requestedMsg		메세지 창에 띄울 문구
* @param		buttonStr0		첫번째 버튼 이름
* @param		buttonStr1		두번째 버튼 이름
* @return		void
*/
PopupModule.openPopupFocus = function (requestedMsg, requestedFunc, requestedTime, buttonStr0, buttonStr1) {
	TRACE("START PopupModule.openPopupFocus()");
	if ((requestedMsg != null) && (requestedFunc != null) && (requestedTime != null)) {
		TRACE("openPopupFocus("+requestedMsg+","+requestedTime+")");
		this.callbackFunc = requestedFunc;
		this.setPopupWindow (requestedMsg.length);
		
		if ((buttonStr0 == null)&&(buttonStr1 == null)) {
			this.createPopupHtml (requestedMsg, 1);
			document.getElementById("UIPopupOneHelpLayer").style.visibility =  "visible";
        } else if ((buttonStr0 != null) && (buttonStr1 == null)) {
			this.createPopupHtml (requestedMsg, 1, buttonStr0);
			document.getElementById("UIPopupOneHelpLayer").style.visibility =  "visible";
        } else if ((buttonStr0 != null) && (buttonStr1 != null)) {
			this.createPopupHtml (requestedMsg, 2, buttonStr0, buttonStr1);
			document.getElementById("UIPopupTwoHelpLayer").style.visibility =  "visible";
        }
		this.popupTimerProcess (this.TIMER_SET, requestedTime);
		this.turnPopup("on");
		document.getElementById("popupButton1").focus();
		if ((buttonStr0 != null)) {
            document.getElementById("popupButton0").style.backgroundImage= "url('img/button_normal.png')";
        }
		TRACE("openPopupFocus("+requestedMsg+","+requestedTime+") Ends.");
	}
	TRACE("END PopupModule.openPopupFocus()");
}

/**
 * @brief			팝업을 연다
 * @remarks		지정된 사이즈로 화면 중앙에 팝업을 생성한다.
* @param		requestedMsg		메세지 창에 띄울 문구
* @param		buttonStr0		첫번째 버튼 이름
* @param		buttonStr1		두번째 버튼 이름
* @return		void
*/
PopupModule.openPopupNoBt = function (requestedMsg, requestedFunc, requestedTime) {
	if ((requestedMsg != null) && (requestedFunc != null) && (requestedTime != null)) {
    	this.callbackFunc = requestedFunc;
    	this.setPopupWindow (requestedMsg.length);
    
        this.createPopupHtml(requestedMsg, 0);
    	
    	this.popupTimerProcess (this.TIMER_SET, requestedTime);
    	this.turnPopup("on");
    	document.getElementById("noBt").focus();
	}
}


PopupModule.popupTimerProcess = function(mode, timer) {
	TRACE("popupTimerProcess("+mode +"," + timer+")");
	switch (mode) {
		case this.TIMER_SET :
			if (timer != -1) {
				this.gPopupTimer = eval(timer) * 1000;
				this.resetCloseTimer();
			}
			else {
				this.gPopupTimer = false;
			}
			break;
		case this.TIMER_RESET :
			if (this.gPopupTimer != false)
				this.resetCloseTimer ();
			break;
		default:
			break;
	}
	TRACE("popupTimerProcess("+mode +"," + timer+") Ends.");
}

/**/
PopupModule.resetCloseTimer = function() {
	if (this.gPopupInstance != null)  {
		clearTimeout(this.gPopupInstance);
    }
	this.gPopupInstance = setTimeout("PopupModule.closePopup()", this.gPopupTimer);
}

/**
 * @brief			팝업을 닫는다.
 * @remarks		지정된 사이즈로 화면 중앙에 팝업을 생성한다.
* @param		void
* @return		void
*/
PopupModule.closePopup = function(optionButton) {
	TRACE("closePopup()");
	this.turnPopup ("off");
	if (PopupModule.callbackFunc)
		PopupModule.callbackFunc(-1);
	TRACE("closePopup() Ends.");	
}

/**
 * @brief		비정상 팝업을 닫는다.
 * @remarks		
* @param		void
* @return		void
*/
PopupModule.destroy = function() {
	TRACE("destroy()");
	if (this.gPopupInstance != null)  {
		clearTimeout(this.gPopupInstance);
    }
	this.turnPopup ("off");
	TRACE("destroy() Ends.");	
}

/**
 * @brief			팝업 보이기/감추기
 * @remarks		팝업을 option에 따라 보이거나 감춘다
* @param		option		on/off option
* @return		void
*/
PopupModule.turnPopup = function(option) {
	TRACE("turnPopup("+option+")");
	if (option == "on") {
		//WMMain.addDeactivateEvent('PopupModule',function(){
		//	PopupModule.turnPopup('off')
		//});
		document.getElementById ("UIPopupDiv").style.display = "block";
//		document.getElementById ("UIPopupDiv").innerHTML = "&nbsp";
	} else if (option == "off") {
		//WMMain.delDeactivateEvent('PopupModule');
		document.getElementById ("UIPopupDiv").style.display = "none";
		document.getElementById("UIPopupOneHelpLayer").style.visibility =  "hidden";
		document.getElementById("UIPopupTwoHelpLayer").style.visibility =  "hidden";
//		document.getElementById ("UIPopupDiv").innerHTML = "";
		if (PopupModule.gPopupInstance != null) clearTimeout (PopupModule.gPopupInstance);
	}
	TRACE("turnPopup("+option+") Ends.");	
}

/**
 * @brief			팝업 버튼에 포커스가 있을 때 화면 처리
 * @remarks		팝업 버튼 바탕에 이미지를 배경으로 깔아서 포커스 효과를 나타낸다.
* @param		obj		HTML Object
* @return		void
*/
PopupModule.popupFocus = function(obj) {
	TRACE("popupFocus(obj)");
	obj.style.backgroundImage = "url('img/button_select.png')";
}

/**
 * @brief			팝업 버튼에서 포커스를 벗어날 때 화면 처리
 * @remarks		팝업 버튼 바탕에 이미지를 없애고 투명하게 만든다.
* @param		obj		HTML Object
* @return		void
*/
PopupModule.popupBlur = function(obj) {
	TRACE("popupFocus(obj)");
	obj.style.backgroundImage = "url('img/button_normal.png')";
}

/**
 * @brief			팝업에서의 key 처리
 * @remarks		팝업에서 사용되는 키에 따른 action을 지정한다.
* @param		obj		HTML Object
* @return		void
*/
PopupModule.popupKeyDown = function(obj) {
//	var ie = (document.all) ? 1:0
//	if (ie) { var EKC = event.keyCode;}
	var EKC = event.keyCode;
	TRACE("popupKeyDown() :: " + EKC);
//    WMMain.commonKeyHandler(KEY_EMPTY);

	var Idx = obj.name;
	Idx = eval(Idx);
	var tmpMenu;
	switch (EKC) {
		case(39) : // Right
		case(5) :
        case(29469): // remocon wheel right
        case(160): // 패널 키 Right
        	TRACE("right");
			if(bMaple && EKC==39) return false;
			if (Idx < this.MAX_MENU_NUM) {
                 Idx+=1;
            } else {
                Idx = 0;
            }
			document.getElementById ("popupButton"+Idx).focus();
			this.popupTimerProcess (this.TIMER_RESET);
			break;
		
		case (37) : // Left
		case (4) :
        case(29468): // remocon wheel left
        case(161): // 패널 키 Left
        	TRACE("left");
			if(bMaple && EKC==37) return false;
			if (Idx > 0) {
            	Idx-=1;
            } else {
                Idx = this.MAX_MENU_NUM;
            }
            TRACE("Idx : " + Idx);
			document.getElementById ("popupButton"+Idx).focus();
			this.popupTimerProcess (this.TIMER_RESET);
			break;
		
		case (13) : //Enter
        case (29443) : 
        case(164): // 패널 키 Enter
			if(bMaple && EKC==13) return false;
			//
			this.turnPopup ("off");	
            //logic 처리 부분
			if (PopupModule.callbackFunc){
				PopupModule.callbackFunc(Idx);
			}
			
			break;
			
        case (27) :
        case (88) : //ESC Key
        case(163): // 패널 키 ESC
        case (45): //Exit Key
        	if(bMaple && EKC==27) return false;
            blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다

			this.closePopup();
       		break;
	}	
}

/**
 * @brief			팝업에서의 key 처리
 * @remarks		팝업에서 사용되는 키에 따른 action을 지정한다.
* @param		obj		HTML Object
* @return		void
*/
PopupModule.popupNoBTKeyDown = function(obj) {
//	var ie = (document.all) ? 1:0
//	if (ie) { var EKC = event.keyCode;}
    var EKC = event.keyCode;
    TRACE("popupNoBTKeyDown() : " + EKC);
    
//    blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다
    return;
}

/**
 * @brief			팝업의 위치, 크기 Setting
 * @remarks		메세지의 길이를 통하여 창의 크기와 위치를 Setting 한다.
 * @param		msgLength		메세지 창에 띄울 문구의 길이
 * @return		void
*/
PopupModule.setPopupWindow = function(msgLength) {
	TRACE ("setPopupWindow (msgLength)::"+msgLength);
	var msgLength = msgLength;
	var popupHeight;
	
	popupHeight = 183 + Math.floor(msgLength/15)*10;
	TRACE("popupHeight :: "+popupHeight)
	if ( popupHeight >  233) {
		document.getElementById("UIPopupDiv").style.backgroundImage="url(img/popup_bg_02.png)";
		document.getElementById("UIPopupMsg").style.height = "160px";
		popupHeight = "262";	
	} else {
		document.getElementById("UIPopupDiv").style.backgroundImage="url(img/popup_bg_01.png)";
		document.getElementById("UIPopupMsg").style.height = "110px";
		popupHeight = "203";	
    }
	var popupWidth = 424; // Hard Coding
	var popupLeftPos = Math.floor ((960-popupWidth) / 2);
	var popupTopPos = Math.floor ((540-popupHeight) / 2);


	document.getElementById ("UIPopupDiv").style.left = popupLeftPos + "px";
	document.getElementById ("UIPopupDiv").style.top = popupTopPos + "px";
	document.getElementById ("UIPopupDiv").style.height = popupHeight + "px";
}

/**
 * @brief			팝업의 Html 구성
 * @remarks		팝업의 Html을 입력 인수들을 이용하여 동적으로 구성
* @param		requestedMsg		메세지 창에 띄울 문구
* @param		numOfButton		버튼의 갯수
* @param		buttonStr0		첫번째 버튼 이름
* @param		buttonStr1		두번째 버튼 이름
* @return		void
*/
PopupModule.createPopupHtml = function(requestedMsg, numOfButton, buttonStr0, buttonStr1) {
	TRACE ("createPopupHtml (requestedMsg, numOfButton, buttonStr0, buttonStr1)");
	this.MAX_MENU_NUM = eval(numOfButton) - 1;
	
	buttonName0 = SID_OK;
	buttonName1 = SID_CANCEL;
	
	var tempRequestedMsg;
	var tempMsg;
	
	tempRequestedMsg = "<table width='100%' height='100%' border='0' cellpadding = '0px' cellspacing='0px'><tr><td style='text-align : center' vertical-align : middle;'>"+requestedMsg+"</td></tr></table>";
	
	// To make HTML for buttons
    if (numOfButton == 0) {
        tempHtml = "<table border = '0' width = '0px'  cellpadding='0px' cellspacing='0px'><tr><td><a href='javascript: void(0)' id='noBt' onkeydown='javascript:PopupModule.popupNoBTKeyDown(this)'></td></tr></table>";
    } else {
    	if (numOfButton == 1)
    		tempHtml = "<table border = '0' width = '108px' cellpadding='0px' cellspacing='0px'>";
    	else if (numOfButton == 2)
    		tempHtml = "<table border = '0' width = '216px' cellpadding='0px' cellspacing='0px'>";
    
    	if (buttonStr0 != null) buttonName0 = buttonStr0;
    	tempHtml += "<tr><td align = 'right' valign = 'middle'>";
    	tempHtml += "<a href='javascript: void(0);' onkeydown='javascript:PopupModule.popupKeyDown(this);' onfocus='javascript:PopupModule.popupFocus(this);' onblur='javascript:PopupModule.popupBlur(this);' id = 'popupButton0' name = '0' >";
    	tempHtml += "<table width = '108px' height = '35px' border = '0' cellpadding='0px' cellspacing='0px'><tr><td align = 'center'>";
    	tempHtml += buttonName0;
    	tempHtml += "</td></tr></table></a></td>";
    	
    	// In case that there are two buttons
    	if (numOfButton == 2) {
    		if (buttonStr1 != null) {
    			buttonName1 = buttonStr1;
    		}
    		tempHtml += "<td align = 'right' valign = 'middle'>";
    		tempHtml += "<a href='javascript: void(0);' onkeydown='javascript:PopupModule.popupKeyDown(this);' onfocus='javascript:PopupModule.popupFocus(this);' onblur='javascript:PopupModule.popupBlur(this);' id = 'popupButton1' name = '1'>";
    		tempHtml += "<table width = '108px' height = '35px' cellpadding='0px' cellspacing='0px'><tr><td align = 'center'>";
    		tempHtml += buttonName1;
    		tempHtml += "</td></tr></table></a></td>";
    	}
    	tempHtml += "</tr></table>";        
    }

	// Put buttons into 'msg' and 'buttonTable' div
	document.getElementById("UIPopupMsg").innerHTML = tempRequestedMsg;
	document.getElementById("UIPopupButton").innerHTML = tempHtml;
}

