/**
* @file      ucc_3.js
* @brief     위젯의 동작 및 화면을 제어하는 자바스크립트  
* @author    Hyun Park
* @date      04 JUL 2008  
*/



/**
 * @brief			checkList 초기화 
 * @remarks		
 * @param		void
 * @return	 	void
*/
function initCheckList(){
	var i;
	for(i = 0;  i < checkList.length; i++)
		checkList[i] = false;	
	if(checkPlayList.length != 0)
		checkPlayList.splice(0,checkListCnt);		
	checkListCnt = 0;	
}
/**
 * @brief			checkList 추가 
 * @remarks		
 * @param		void
 * @return	 	void
*/
function addCheckList(Idx){
	checkList[Idx] = true;		
	checkPlayList[checkListCnt++] = Idx;	
	
	for(var i=0; i<checkPlayList.length; i++)	{
		alert("checkPlayList["+i+"] :: "+checkPlayList[i])
	}
}

/**
 * @brief			checkList 삭제 
 * @remarks		
 * @param		void
 * @return	 	void
*/
function deleteCheckList(Idx){
	var i;
	checkList[Idx] = false;	
	for(i=0; i < checkPlayList.length; i++){
		if(checkPlayList[i] == Idx){
			checkPlayList.splice(i,1);
		}
	}
	checkListCnt--;
}
/**
 * @brief			checkList 전체 선택 
 * @remarks		
 * @param		void
 * @return	 	void
*/
function selectAllCheckList(Idx)
{
	TRACE("Idx in selectAllCheck :: "+Idx);
	var i;
	initCheckList();
	for(i = 1; i<=contentsListNum; i++)	
	{
		checkList[i] = true;
		checkPlayList[checkListCnt++] = i;	
	}
	checkListCnt = contentsListNum;	
	createRightSideHTML(calculateIndexOfPage(Idx-1, showNumOfPage));
}
/**
 * @brief			checkList 전체 삭제 
 * @remarks		
 * @param		void
 * @return	 	void
*/
function deleteAllCheckList(Idx)
{
	var i;
	for(i = 1; i<checkList.length; i++)	
	{
		checkList[i] = false;
	}
	checkPlayList.splice(0,checkListCnt);
	checkListCnt = 0;	
	createRightSideHTML(calculateIndexOfPage(Idx-1, showNumOfPage));
}

/**
 * @brief			checkList에 check된 여부 확인 
 * @remarks		
 * @param		void
 * @return	 	void
*/
function searchCheckList(Idx){
	if(checkList[Idx] == true)
		return true;
	else
		return false;	
}

/**
 * @brief			checkList에서 play할 영상 순서 리턴 
 * @remarks		
 * @param		void
 * @return	 	void
*/
function searchPlayList(Idx)
{	
	var i;
	TRACE("=========searchPlayList==========");
	for(i = 0; i < checkPlayList.length; i++)
	{
		if(checkPlayList[i] == Idx)
		{
			return i;
		}
	}	
}

/**
 * @brief			deatilscroll 보여줌 
 * @remarks		
 * @param		void
 * @return	 	void
*/
function showDetailscroll () {
	TRACE("showDetailscroll");
	var tReailHeight = document.getElementById('uccDescription').scrollHeight;
	SCROLL_REAL_HEIGHT = document.getElementById('uccDescription').scrollHeight - SCROLL_HEIGHT;	
	document.getElementById("detaildrag").style.top = "0px";
	TRACE ("showDetailscroll : SCROLL_REAL_HEIGHT = " + SCROLL_REAL_HEIGHT + "px");
	if (SCROLL_REAL_HEIGHT <1) {
		document.getElementById("detailscroll").style.visibility = "hidden";		
		document.getElementById("detailscrollbar").style.visibility = "hidden";
		document.getElementById("detaildrag").style.visibility = "hidden";		
	}
	else {
		document.getElementById("detailscroll").style.visibility = "visible";
		document.getElementById("detailscrollbar").style.visibility = "visible";
		document.getElementById("detaildrag").style.visibility = "visible";
	}
}

/**
 * @brief		deatilscroll 숨김 
 * @remarks		
 * @param		void
 * @return	 	void
*/
function hideDetailscroll() {
	document.getElementById("detailscroll").style.visibility = "hidden";
	document.getElementById("detailscrollbar").style.visibility = "hidden";
	document.getElementById("detaildrag").style.visibility = "hidden";	
}

/**
 * @brief			상세보기 창의 description의 scroll 키 입력 함수. 
 * @remarks	deatilscroll controll	
 * @param		"up", "down", "none"
 * @return	 	void
*/
function detailScrollControl (direction) {
	TRACE("detailScrollControl : "+document.getElementById('uccDescription').scrollHeight);
	TRACE ("detailScrollControl : SCROLL_REAL_HEIGHT = " + SCROLL_REAL_HEIGHT + "px");
	if  (SCROLL_REAL_HEIGHT < 0){		
		SCROLL_REAL_HEIGHT = 0;
		return;
	} 
	switch (direction) {
		case "up" :
			TRACE("SCROLL_POSITION : "+document.getElementById ('uccDescription').scrollTop);
			SCROLL_POSITION = document.getElementById ('uccDescription').scrollTop - SCROLL_MOVE_HEIGHT ;
			if (SCROLL_POSITION < 0) SCROLL_POSITION = 0;
			break;
		case "down" :
			TRACE("SCROLL_POSITION : "+document.getElementById ('uccDescription').scrollTop);
			SCROLL_POSITION = document.getElementById ('uccDescription').scrollTop + SCROLL_MOVE_HEIGHT ;
			if (SCROLL_POSITION > SCROLL_REAL_HEIGHT) SCROLL_POSITION = SCROLL_REAL_HEIGHT;
			break;
		default :
			TRACE("default ");
			SCROLL_POSITION = 0;
			document.getElementById("detaildrag").style.top = "0px";
			break;
	}
	if (SCROLL_REAL_HEIGHT == 0) {
        detailDragT = 0;
    } else {
        document.getElementById("detailscroll").style.visibility = "visible";
	    detailDragT = Math.ceil ((SCROLL_POSITION/SCROLL_REAL_HEIGHT) * (SCROLL_HEIGHT - 17)); //(��ü���� - 39 : scroll drag button size�̹������)
        TRACE("detailDragT ::: "+detailDragT);
        moveToForDetail();
    }
}

/**
 * @brief			description의 scroll drag 이동 함수. 
 * @remarks	moveToForDetail	
 * @param		void
 * @return	 	void
*/
function moveToForDetail(){
	TRACE("moveToForDetail detailDragT = "+detailDragT);
    document.getElementById("detaildrag").style.visibility="visible";
	document.getElementById("detaildrag").style.position = "absolute";
    document.getElementById("detaildrag").style.top = detailDragT + "px";
}

/**
 * @brief			검색 history 생성 함수
 * @remarks	create search history	
 * @param		void
 * @return	 	void
*/
function createSearchHistoryList(index){
	TRACE("createSearchHistoryList() :: "+ index);
	var tmpID;
	var tmpIndex;
	var tmpLine;
	var totalLine = "";
	var maxI = 0;
	var tmpPage = index/showNumOfListPage;
	 tmpPage = Math.floor(tmpPage);
	var lastFocus = 1;
	var tmpHistoryIndex = index + 1;
	searchHistoryListNum = searchHistoryList.length;
	
	//Total Page와 CurrentPage 계산
    totalListPage = Math.ceil(searchHistoryListNum/showNumOfListPage);
    currentListPage = Math.ceil((index+1)/showNumOfListPage);

	hideSearchHistoryScrollBar();
	if(totalListPage > 1 ) {
		showSearchHistoryScrollBar();
		searchHistoryScrollBar();
	}	

	if ((tmpPage+1) * showNumOfListPage > searchHistoryListNum) {
        maxI = searchHistoryListNum;
    } else {
        maxI = (tmpPage+1) * showNumOfListPage;
    }	
	TRACE("tmpPage*showNumOfListPage ::: "+tmpPage*showNumOfListPage)
	TRACE("maxl :: "+maxI)
	for ( i=(tmpPage*showNumOfListPage) ; i < maxI ; i++) {
	    totalLine += "<ul style= 'padding-left: 0px;'>";
		tmpID = historyID + (i + 1);
		tmpIndex = i+1;
		
		tmpLine = "<li><a id=" + tmpID + " href=javascript: onkeydown=searchHistoryBoxInputKey(this); onfocus=searchHistoryBoxFocus(this); onblur=searchHistoryBoxBlur(this); name=" + tmpIndex +"><table cellspacing=0 cellpadding=0 width=100% border=0px style='table-layout:fixed;'><tr><td width=584px height=36px;><div class='list_history' style='width:564px; height:28px; overflow:hidden; white-space : nowrap; text-overflow : ellipsis;'>" + searchHistoryList[i] + "</div></td></tr></table></a></li>";	
		
		totalLine += tmpLine;
	    totalLine += "</ul>";
	}
	document.getElementById('historyList').innerHTML = totalLine;	
	document.getElementById('historyCount').innerHTML = currentListPage + "/" + totalListPage;
	
	if( totalListPage != 0) {
		document.getElementById('historyCount').style.visibility="visible";
	}else {
		document.getElementById('historyCount').style.visibility="hidden";
	}
	
	if (locateFocus==historyID) {
        index++;
        document.getElementById(historyID+index).focus();        
    }
	lastSearchHistoryID = historyID+tmpHistoryIndex;
}

/**
 * @brief			검색 history 키 입력 함수
 * @remarks		
 * @param		obj
 * @return	 	void
*/
function searchHistoryBoxInputKey(obj) {
//    var ie = (document.all) ? 1:0
//    if (ie) { var EKC = event.keyCode;}
	var EKC = event.keyCode;
    var Idx = obj.name; //해당 Index 가져오기..
    var tmpContentsID;
	var tmpText;
	CommonLib.keyHandler(EKC,popupCallback);	
    switch (EKC) {
	   case (37) : 		//Left 화살표...
       case (29459) : //Left 화살표...
       case (tvKey.KEY_LEFT) : // left      
       case (tvKey.KEY_PANEL_VOL_DOWN): 		// 패널 키 Left
       		bOnCategoryList = true;
			document.getElementById(lastCategoryID).focus();			
			break;
		case (38) : 		//Up 화살표....
        case (tvKey.KEY_UP) : //Up 화살표....
        case (tvKey.KEY_WHEELUP): 	// remocon wheel left
        case (tvKey.KEY_PANEL_CH_UP) :			// 패털키 UP
        	if(bMaple && EKC==38) return false;
            if (Idx>1) {
                locateFocus = historyID;
                Idx--;
                //화면이 전환되야 하는경우 새롭게 그려준다
                if (Idx%showNumOfListPage==0) {
                    createSearchHistoryList( Idx-1 );
                } else {
					tmpContentsID = historyID + Idx;
                    document.getElementById(tmpContentsID).focus();
                }
            } else { // 제일 위에서 위 화살표 누르면 가장 뒤로 이동 
			    document.getElementById("orderByItem5").focus();			   
			}
        break;
		
		case (40) : 		//down 화살표...
        case (tvKey.KEY_DOWN) : //down 화살표...
        case (tvKey.KEY_WHEELDOWN): 	// remocon wheel right
        case (tvKey.KEY_PANEL_CH_DOWN):		// 패널키 Down 
        	if(bMaple && EKC==40) return false;
	        if (Idx<searchHistoryListNum) {
                locateFocus = historyID;
                var tmpIdx = Idx;
                Idx++;
                //화면이 전환되야 하는경우 새롭게 그려준다
                if (Math.ceil(Idx/showNumOfListPage)>Math.ceil(tmpIdx/showNumOfListPage)) {
                    createSearchHistoryList( Idx-1 );
                } else {
                    tmpContentsID = historyID + Idx;
	                document.getElementById(tmpContentsID).focus();                               
                }            
            } else {
				document.getElementById("orderByItem5").focus();			   
			}
        break;
		
		case (13) : 		//Enter
        case (tvKey.KEY_ENTER) : //Enter
        case (tvKey.KEY_PANEL_ENTER) : 	// 패널 키 Enter
        case (tvKey.KEY_PANEL_SOURCE) : 	// 패널 키 Source
        		if(bMaple && EKC==13) return false;
				tmpText = searchHistoryList[Idx-1];
				createSearchPopup();
			 	showSearchPopup(); 	 
				
				document.getElementById("searchText1").maxLength = 50;
				ime.setString(tmpText);
			  	lastSearchHistoryID = obj.id
				ime.setKeyFunc(tvKey.KEY_RETURN,function(){
					hideSearchPopup();
					clearGoogleSuggestList();
					document.getElementById(lastSearchHistoryID).focus();
					return true;
				});
				ime.setKeyFunc(tvKey.KEY_EXIT,function(){
					hideSearchPopup();
					clearGoogleSuggestList();
					document.getElementById(lastSearchHistoryID).focus();
					return true;
				});
				document.getElementById(searchTextInput).focus();
				showHelpLayerIME();
        break;
		
	    case (123) : //F12 PC
		case (tvKey.KEY_TOOLS) : 	// 간편메뉴 TV
        	if(bMaple && EKC==120) return false; 		
				deleteHistoryListNum = Idx;
				document.getElementById("helpLayerHistoryList").style.visibility="hidden";
				var popupMenu = new Array(SID_DELETE, SID_DELETE_ALL);  //new Array('삭제', '전체 삭제'); // 팝업 메뉴 이름
				lastFocusID = historyID + Idx;
				curPopup = POPUP_HISTORY_DEL;
				createOptionPopup( popupMenu, searchHistory_popup_inputKey, new Array(false, false) );
				showOptionPopup();		
			break;		    
		
		//case (27) : 	//ESC
        case (tvKey.KEY_RETURN) : 	// ESC
        case (tvKey.KEY_PANEL_MENU): 	// 패널 키 ESC
//        case (BUTTON_EXIT): 	//Exit Key       
//        	if(bMaple) return false; 
	        blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다       
	        bOnCategoryList = true;
	        lastSearchHistoryID = obj.id 
			document.getElementById(lastCategoryID).focus();
       		break;	
		
        default  : 
			
			
        	return false;
        	break;
    }	
}
/**
 * @brief			검색 history 삭제 popup 키 입력 함수
 * @remarks		
 * @param		EKC	obj
 * @return	 	void
*/
function searchHistory_popup_inputKey(EKC, obj) {
	var EKC = event.keyCode;
	CommonLib.keyHandler(EKC,popupCallback);	
    var Idx = obj.name; //해당 Index 가져오기..
	TRACE("history_popup Idx :::"+Idx);
    switch (EKC) {
//        case (13) : 		//Enter
        case (tvKey.KEY_ENTER) : //Enter       
        case (tvKey.KEY_PANEL_ENTER) : 	// 패널 키 Enter
        case (tvKey.KEY_PANEL_SOURCE) : 	// 패널 키 Source
        	var sendMsg;
        	if(bMaple && EKC==13) return false;     
			if ( Idx == 1 ) { // 하나만 지우기
				bHistoryDeleteAll = false;
				TRACE("bHistoryDeleteAll = " + bHistoryDeleteAll);
				sendMsg = SID_BOOKMARK_DEL_CONFIRM; //"선택된 항목을 삭제하시겠습니까?";
			} else {	// 모두 지우기 
				bHistoryDeleteAll = true;
				TRACE("bHistoryDeleteAll = " + bHistoryDeleteAll);				
				sendMsg = SID_BOOKMARK_DELALL_CONFIRM; //"전체 항목을 삭제하시겠습니까?";				
			}
			hideOptionPopup();
			openPopupFocusWithTimer(sendMsg, popupCallback, SID_YES,SID_NO, 30);
        	break;
		
        default  : 
				
        	return false;
        	break;
    }	
}

/**
 * @brief			검색 history 추가 함수
 * @remarks	searchhistoryList array에 검색어 추가
 * @param		key		검색어
 * @return	 	void
*/
function addSearchHistoryList(key){
	TRACE("addSearchHistoryList() :: "+key);
	if(searchHistoryList == null) searchHistoryList = new Array();
	bCheckHistory = true;
	var tCnt = 0;
	for(var i = 0; i<key.length; i++){		
		if(key[i] === " ") tCnt++;		
	}
	if(key.length == tCnt) return;
	for( var i =0; i < searchHistoryList.length; i++){		
		if(	searchHistoryList[i] == key ){
			TRACE(" same words!!!");
			bCheckHistory = false;
		} 
	}	
	
	if( bCheckHistory && searchHistoryCnt < 20){
		searchHistoryList.unshift(key);
		searchHistoryCnt++;	
	}	
	else if( bCheckHistory && searchHistoryCnt >= 20 ){
		searchHistoryList.unshift(key);	//array의 맨 처음에 저
		searchHistoryList.pop();		//array의 마지막 값 제거		
	}
}

/**
 * @brief			검색 history 삭제 함수
 * @remarks	delete search history	
 * @param		index	삭제할 list의 index 값
 * @return	 	void
*/
function deleteSearchHistoryList(index){
	TRACE("deleteSearchHistoryList()::: "+index);
	var tmpCnt = index -1;
	
	if(bHistoryDeleteAll == false){
		searchHistoryList.splice(tmpCnt, 1);		//array에서 선택한 index의 값을 빼낸다.
		searchHistoryCnt--;
		createSearchHistoryList(0);
		saveSearchHistoryFile();		//파일에 기록.		
		if( searchHistoryCnt == 0)
			document.getElementById("orderByItem5").focus();			
		else
			document.getElementById("historyListItem1").focus();

	}else{
		while(searchHistoryCnt>0){
			searchHistoryList.pop();
			searchHistoryCnt--;
		}
		createSearchHistoryList(0);
		saveSearchHistoryFile();		//파일에 기록.		
		//document.getElementById("searchText1").focus();		
		document.getElementById("orderByItem5").focus();			
	}
}

/**
 * @brief			정렬방식 변경 함수
 * @remarks	
 * @param		key		정렬방식
 * @return	 	void
*/
function changeOrderby(key){
	TRACE("changeOrderby key :::: "+key);
	switch(key){
		case(RELEVANCE):
			order = "relevance";			
		break;
		case(PUBLISHED):
			order = "published";
		break;
		case(VIEWCOUNT):
			order = "viewCount";
		break;
		case(RATING):
			order = "rating";
		break;
		default:
			TRACE("error!!!! wrong order");
		break;
	}
}

/**
 * @brief		정렬방식 관련 키 입력 함수
 * @remarks	
 * @param		obj		HTML Object
 * @return	 	void
*/
function order_inputkey(obj){
//	var ie = (document.all) ? 1:0
//    if (ie) { var EKC = event.keyCode;}    
	var EKC = event.keyCode;
    var Idx = obj.name;
	keyCnt = Idx;
	var tmpID;
	var tmpRadioID;
	CommonLib.keyHandler(EKC,popupCallback);	
    switch (EKC) {
//        case (37) : 		//Left 화살표...
//       case (29459) : //Left 화살표...
       case (tvKey.KEY_LEFT) : // left
       case (tvKey.KEY_WHEELUP): 	// remocon wheel left
       case (tvKey.KEY_PANEL_VOL_DOWN): 		// 패널 키 Left
			// move caret left
			if(Idx ==1){
				bOnCategoryList = true;
				document.getElementById(lastCategoryID).focus();
				
			}else{				
				Idx--;
				keyCnt--;
				tmpID = orderID + Idx;
				document.getElementById(tmpID).focus();
			}					
			break;
//        case (39) : 		//Right 화살표...
//        case (29458) : //Right 화살표...
        case (tvKey.KEY_WHEELDOWN): 	// remocon wheel right
        case (tvKey.KEY_RIGHT):
		case (tvKey.KEY_PANEL_VOL_UP) : 	// 패널키 Right
			// move caret right
			if(Idx == 4) {
				Idx++;
				tmpID = orderID + Idx;								
				document.getElementById(tmpID).focus();
			}
			else if(Idx == 5){
				if( searchHistoryCnt != 0){
					createSearchHistoryList( 0 );
					document.getElementById( historyID + "1" ).focus();
				}
			}else{				
				Idx++;
				keyCnt++;
				tmpID = orderID + Idx;
				document.getElementById(tmpID).focus();
			}			
		break;	
		
//		case (38) : 		//Up 화살표....
        case (tvKey.KEY_UP) : //Up 화살표....
        case (tvKey.KEY_PANEL_CH_UP) :			// 패털키 UP		
            if(bMaple && EKC==38) return false;
			lastOrderID = obj.id;            
			if( searchHistoryCnt != 0){
				createSearchHistoryList(searchHistoryListNum-1);
				document.getElementById( historyID + searchHistoryListNum).focus();
			}				
        	break;
			
//		case (40) : 		//down 화살표...
        case (tvKey.KEY_DOWN) : //down 화살표... 
        case (tvKey.KEY_PANEL_CH_DOWN):		// 패널키 Down 	
        	if(bMaple && EKC==40) return false;        
			lastOrderID = obj.id;            
			if( searchHistoryCnt != 0){
				createSearchHistoryList( 0 );
				document.getElementById( historyID + "1" ).focus();
			}
        	break;        
			
		//case (27) : 	//ESC
        case (tvKey.KEY_RETURN) : 	// ESC     
        case (tvKey.KEY_PANEL_MENU): // 패널 키 ESC
//        	if(bMaple) return false;   
			bOnCategoryList = true;
			lastOrderID = obj.id;
        	blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다
        	lastFocusID = lastCategoryID;        	
        	document.getElementById(lastCategoryID).focus();
			
        break;	
		
//		case (13) : 		//Enter
        case (tvKey.KEY_ENTER) : //Enter       
        case (tvKey.KEY_PANEL_ENTER) : 	// 패널 키 Enter
        case (tvKey.KEY_PANEL_SOURCE) : 	// 패널 키 Source
        	if(bMaple && EKC==13) return false;     
			if(Idx < 5){
				TRACE("lastRadioID when Enter:: "+lastRadioID)
		      document.getElementById(lastRadioID).src = "img/radio_button_n.png";	//select
 		      lastRadioID = "radio" +Idx;
			  curRadioID = lastRadioID;
			  changeOrderby(keyCnt);
        	  document.getElementById(lastRadioID).src = "img/radio_button_s.png";	//select
        	} else if( Idx == 5) {
			  createSearchPopup();
			  showSearchPopup(); 	 
			  focusIME();
			}	
		break;
		
		default  : 

        	return false;
        	break;
	}
}
/**
 * @brief		정렬방식에 포커스 있을 때 화면처리
 * @remarks		라디오 버튼과 배경을 변경하여 포커스 효과 나타냄
 * @param		obj		HTML Object
 * @return	 	void
*/
function onFocusOrderBy(obj){
	TRACE("obj.id :::: "+obj.id);
	lastFocusID = obj.id;	
	locateFocus = orderID;
	if(obj.id == "orderByItem1"){
		obj.parentNode.style.border = "none";
   		obj.parentNode.style.backgroundImage = "url(img/sub2_search_box7_s.png)";
	}else if(obj.id == "orderByItem2"){
		obj.parentNode.style.border = "none";
   		obj.parentNode.style.backgroundImage = "url(img/sub2_search_box7_s.png)";
	}else if(obj.id == "orderByItem3"){
		obj.parentNode.style.border = "none";
   		obj.parentNode.style.backgroundImage = "url(img/sub2_search_box7_s.png)";
	}else if(obj.id == "orderByItem4"){
		obj.parentNode.style.border = "none";
   		obj.parentNode.style.backgroundImage = "url(img/sub2_search_box7_s.png)";
	}else{
		obj.parentNode.style.border = "none";
   		obj.parentNode.style.backgroundImage = "url(img/sub2_search_box6_s.png)";
	}	
	hideAllHelpLayer();
	if(searchHistoryCnt == 0)	createHelpLayerOrderByNoHistory();	
	else createHelpLayerOrderBy();
	showHelpLayerOrderBy();
}

/**
 * @brief		정렬방식에 포커스 벗어날 때 화면 처리
 * @remarks		라디오 버튼과 배경을 변경
 * @param		obj		HTML Object
 * @return	 	void
*/
function onBlurOrderBy(obj){
	if( obj.id == "orderByItem5") {
		obj.parentNode.style.border = "none";
   		obj.parentNode.style.backgroundImage = "url(img/sub2_search_box6_n.png)";
	}else {
		obj.parentNode.style.border = "none";
    	obj.parentNode.style.backgroundColor = "transparent";
		obj.parentNode.style.backgroundImage = "url(none)"; 		
	}
}

/**
 * @brief		'내검색어(검색어 history)' 에 포커스 있을 때 화면처리
 * @remarks		배경을 변경하여 포커스 효과 나타냄
 * @param		obj		HTML Object
 * @return	 	void
*/
function searchHistoryBoxFocus(obj){
	TRACE("searchHistoryBoxFocus :: "+searchHistoryListNum);
	lastFocusID = obj.id;	
	locateFocus = historyID;
	changePosOptionPopup(); //optionPopup 위치변경
	 obj.style.border = "none";
  	 obj.style.backgroundImage = "url(img/highlight_sub2_search3.png)";
	 hideAllHelpLayer();
	 if ( searchHistoryListNum > 0 ) {
	 	showHelpLayerHistoryList();
	 }		
	 else {
	 	showHelpLayerHistoryListNoMove();		 
	 }
	 	
}

/**
 * @brief		'내검색어(검색어 history)' 에 포커스 벗어날 때 화면처리
 * @remarks		배경을 변경
 * @param		obj		HTML Object
 * @return	 	void
*/
function searchHistoryBoxBlur(obj){
	obj.style.border = "none";
    obj.style.backgroundColor = "transparent";
	obj.style.backgroundImage = "url(none)"; 
}

/**
 * @brief		관련 동영상 show 함수
 * @remarks		관련 동영상의 div를 show
 * @param		void
 * @return	 	void
*/
function showRelatedUcc() {
	var strTmp ="";	
	document.getElementById("ucc_Related_popup_bg").style.visibility = "visible";
	document.getElementById("ucc_linkbox_bg").style.visibility = "visible";
	document.getElementById("ucc_linkbox_text").innerHTML = SID_RELATED_VIDEO_ABBR_10;
	document.getElementById("ucc_linkbox").style.visibility = "visible";			
	showRelatedScrollBar();
	document.getElementById("ucc_l_arrow").style.visibility = "visible";
	document.getElementById("ucc_r_arrow").style.visibility = "visible";		
	bOnShowRelPopup = true;	
}

/**
 * @brief		관련 동영상 hide 함수
 * @remarks		관련 동영상의 div를 hide
 * @param		void
 * @return	 	void
*/
function hideRelatedUcc(){
	document.getElementById("ucc_Related_popup_bg").style.visibility = "hidden";
	document.getElementById("ucc_linkbox_bg").style.visibility = "hidden";
	document.getElementById("ucc_linkbox").style.visibility = "hidden";			
	hideRelatedScrollBar();
	document.getElementById("ucc_l_arrow").style.visibility = "hidden";
	document.getElementById("ucc_r_arrow").style.visibility = "hidden";	
	bOnShowRelPopup = false;
}

/**
 * @brief		관련동영상 팝업 생성 함수
 * @remarks		관련동영상의 div안 내용을 작성.
 * @param		index		현재 선택한 메뉴의 Index, 0 base		
 * @return	 	void
*/
function createRelatedPopup(index) {
	TRACE("createRelatedPopup() index :::: "+index);
	var tmpLine = "";
	var tmpID;
	var tmpIndex;
	var tmpViewCnt = "";
	var tmpRateAve;
	var tmpPupdate;
	var tmpDuration;
	var tmpCnt=0;
	var tmpFocus;
		
	i = index;

	//lastIndexRel = index + 3;
	lastPreRelIndex = index;
	if( index == gRelContentsListNum-1 ){
		tmpFocus = 0;						//최초 호출시는 맨 마지막부터 그리기 시작 focus는 첫번째것으로 준다.
	} else {
		tmpFocus = index + 1;			//포커스는 항상 가운데이므로 +1을 함.
	}
	
	if( gRelContentsListNum == 1) {
		tmpID = relContentsID + i;
        tmpIndex = i;
		tmpViewCnt = SID_VIEWS + " : " + getCommaNum(relViewcount[i]);
		tmpRateAve =  "<img src=" + getStarImg(relAverage[i]) + ">";
		var tmpStrPupdate = relContentsTime[i];
		tmpPupdate = transferPupdateExpression(tmpStrPupdate);
		if (relDuration[i]) {
			tmpDuration = sec2hrTimeTxt(relDuration[i]);
		} else {
			tmpDuration = sec2hrTimeTxt(0);
		}
		tmpLine += "<div></div>"; 	
		tmpLine += "<div style='background: transparent url(img/sub4_box_2_n.png) scroll no-repeat top left;'><table cellspacing=0 cellpadding=0><tr><td valign= 'middle' align='center' width= 277px height= 45px><span style ='color:#FFFFFF; font-size:18px; '>" + strlength_cut(22, relContentsList[i]) + "</span></td></tr></table><table cellspacing=0  cellpadding=0><tr><td valign= 'middle' align='center' width =120px height=80px rowspan=4><img width=90px height=65px style='border: 1px solid #CCCCCC' src=" + relContentsImg[i] + "></td></tr><tr><td valign= 'middle' align='left' width=155px height=38px><span style='color : #ccffff; font-size:16px; vertical-align:middle; overflow:auto;'>"+tmpViewCnt+"</span></td></tr><tr><td valign= 'middle' align='left' width=155px height=25px><span style='color : #d0d8ff; font-size:18px'>"+tmpPupdate+"</span></td></tr><tr><td valign= 'middle' align='left' width=155px height=17px>"+tmpRateAve+"</td></tr></table><table cellspacing=0 cellpadding=0><tr><td valign= 'middle' align='center' width= 277px height= 30px style='color : #ffffff;  font-size:24px;'><img src='img/time_1.png' width=30px height=24px align='top'>"+tmpDuration+"</td></tr></table><a id="+tmpID+" href=javascript: width=1px height=1px onkeydown=Related_ucc_input(this); onfocus=RelatedFocus(this); onBlur=RelatedBlur(this); name="+tmpIndex+">&nbsp;</a></div>"

		lastFocusID = relContentsID+ tmpFocus;		
	    document.getElementById('uccRelated').innerHTML = tmpLine;
		document.getElementById(relContentsID+ tmpFocus ).focus();	
		
	} else if ( gRelContentsListNum ==2 ) {
		i=0;
		if ( tmpFocus == 0 ){
			tmpLine += "<div></div>";
		}
		while(tmpCnt <2) {
			if ( i > gRelContentsListNum-1 ){
				i = 0;
			}
			tmpID = relContentsID + i;
	        tmpIndex = i;
			tmpViewCnt = SID_VIEWS + " : " + getCommaNum(relViewcount[i]);
			tmpRateAve =  "<img src=" + getStarImg(relAverage[i]) + ">";
			var tmpStrPupdate = relContentsTime[i];			
			tmpPupdate = transferPupdateExpression(tmpStrPupdate);
			if (relDuration[i]) {
				tmpDuration = sec2hrTimeTxt(relDuration[i]);
			} else {
				tmpDuration = sec2hrTimeTxt(0);
			}
		
			tmpLine += "<div style='background: transparent url(img/sub4_box_2_n.png) scroll no-repeat top left;'><table cellspacing=0 cellpadding=0><tr><td valign= 'middle' align='center' width= 277px height= 45px><span style ='color:#FFFFFF; font-size:18px; '>" + strlength_cut(22, relContentsList[i]) + "</span></td></tr></table><table cellspacing=0  cellpadding=0><tr><td valign= 'middle' align='center' width =120px height=80px rowspan=4><img width=90px height=65px style='border: 1px solid #CCCCCC' src=" + relContentsImg[i] + "></td></tr><tr><td valign= 'middle' align='left' width=155px height=38px><span style='color : #ccffff; font-size:16px; vertical-align:middle; overflow:auto;'>"+tmpViewCnt+"</span></td></tr><tr><td valign= 'middle' align='left' width=155px height=25px><span style='color : #d0d8ff; font-size:18px'>"+tmpPupdate+"</span></td></tr><tr><td valign= 'middle' align='left' width=155px height=17px>"+tmpRateAve+"</td></tr></table><table cellspacing=0 cellpadding=0><tr><td valign= 'middle' align='center' width= 277px height= 30px style='color : #ffffff;  font-size:24px;'><img src='img/time_1.png' width=30px height=24px align='top'>"+tmpDuration+"</td></tr></table><a id="+tmpID+" href=javascript: width=1px height=1px onkeydown=Related_ucc_input(this); onfocus=RelatedFocus(this); onBlur=RelatedBlur(this); name="+tmpIndex+">&nbsp;</a></div>"
			tmpCnt++;
			i++;
		}	
		if( tmpFocus == 1 ) {
			tmpLine += "<div></div>";
		}			
		lastFocusID = relContentsID+ tmpFocus;		
	    document.getElementById('uccRelated').innerHTML = tmpLine;
		document.getElementById(relContentsID+ tmpFocus ).focus();			

	} else {
		while(tmpCnt < 3){
			if ( i > gRelContentsListNum-1 ){
				i = 0;
			}
			tmpID = relContentsID + i;
	        tmpIndex = i;

			TRACE("relViewcount[i] :: "+relViewcount[i])
			tmpViewCnt = SID_VIEWS + " : " + getCommaNum(relViewcount[i]);

			tmpRateAve =  "<img src=" + getStarImg(relAverage[i]) + ">";
			
			var tmpStrPupdate = relContentsTime[i];
			tmpPupdate = transferPupdateExpression(tmpStrPupdate);
			
			if (relDuration[i]) {
				tmpDuration = sec2hrTimeTxt(relDuration[i]);
			} else {
				tmpDuration = sec2hrTimeTxt(0);
			}
			tmpLine += "<div style='background: transparent url(img/sub4_box_2_n.png) scroll no-repeat top left;'><table cellspacing=0 cellpadding=0><tr><td valign= 'middle' align='center' width= 277px height= 45px><span style ='color:#FFFFFF; font-size:18px; '>" + strlength_cut(22, relContentsList[i]) + "</span></td></tr></table><table cellspacing=0  cellpadding=0><tr><td valign= 'middle' align='center' width =120px height=80px rowspan=4><img width=90px height=65px style='border: 1px solid #CCCCCC' src=" + relContentsImg[i] + "></td></tr><tr><td valign= 'middle' align='left' width=155px height=38px><span style='color : #ccffff; font-size:16px; vertical-align:middle; overflow:auto;'>"+tmpViewCnt+"</span></td></tr><tr><td valign= 'middle' align='left' width=155px height=25px><span style='color : #d0d8ff; font-size:18px'>"+tmpPupdate+"</span></td></tr><tr><td valign= 'middle' align='left' width=155px height=17px>"+tmpRateAve+"</td></tr></table><table cellspacing=0 cellpadding=0><tr><td valign= 'middle' align='center' width= 277px height= 30px style='color : #ffffff;  font-size:24px;'><img src='img/time_1.png' width=30px height=24px align='top'>"+tmpDuration+"</td></tr></table><a id="+tmpID+" href=javascript: width=1px height=1px onkeydown=Related_ucc_input(this); onfocus=RelatedFocus(this); onBlur=RelatedBlur(this); name="+tmpIndex+">&nbsp;</a></div>"
			tmpCnt++;
			i++;
		}			
		lastFocusID = relContentsID+ tmpFocus;		
	    document.getElementById('uccRelated').innerHTML = tmpLine;
		document.getElementById(relContentsID+ tmpFocus ).focus();		

	}	
}

/**
 * @brief		관련동영상 키 입력  함수
 * @remarks		obj		HTML Object
 * @param		void
 * @return	 	void
*/
function Related_ucc_input(obj){
//	var ie = (document.all) ? 1:0
//    if (ie) { var EKC = event.keyCode;}
	var EKC = event.keyCode;
	TRACE("lastPreRelIndex :: "+ lastPreRelIndex);
    CommonLib.keyHandler(EKC,popupCallback);	
    var Idx = obj.name; //해당 Index 가져오기..
	switch (EKC) {
//        case (37) : 		//Left 화살표...
//        case (29459) :  
        case (tvKey.KEY_WHEELUP): 	// remocon wheel left   
        case (tvKey.KEY_LEFT) :	//Left 화살표...  
		case (tvKey.KEY_PANEL_VOL_DOWN): 		// 패널 키 Left
			if(bMaple && EKC==37) return false;
			if(lastPreRelIndex>0){
				lastPreRelIndex--;		
			} else {
				lastPreRelIndex = gRelContentsListNum-1;
			}			
			createRelatedPopup(lastPreRelIndex);
			RelatedScroll("left");
        	break;
        
        case (39) : 		//Right 화살표...
        case (29458) :      
        case (tvKey.KEY_WHEELDOWN): 	// remocon wheel right  
        case (tvKey.KEY_RIGHT):     		//Right 화살표...         
		case (tvKey.KEY_PANEL_VOL_UP) : 	// 패널키 Right   
			if(bMaple && EKC==39) return false;
			if(lastPreRelIndex < gRelContentsListNum-1){
				lastPreRelIndex++;			
			} else {
				lastPreRelIndex = 0;
			}					
			createRelatedPopup(lastPreRelIndex);
			RelatedScroll("right");	
        	break;
		//case (27) : 		//ESC
        case (tvKey.KEY_RETURN) : 		// ESC        
        case (tvKey.KEY_PANEL_MENU): 		// 패널 키 ESC
//        	if(bMaple) return false;
			blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다
			hideRelatedUcc();
			lastFocusID = focusItem1X;
			document.getElementById(lastFocusID).focus();			
       		break;	
		case (13) : 		//Enter
        case (tvKey.KEY_ENTER) : //Enter       
        case (tvKey.KEY_PANEL_ENTER) : 	// 패널 키 Enter
        case (tvKey.KEY_PANEL_SOURCE) : 	// 패널 키 Source
        	if(bMaple && EKC==13) return false;     
			hideRelatedUcc();
			createRelatedHTML(Idx);
			TRACE("idx :::: "+ Idx);
        	break;
			
		case (33) :    //Page Up
        case (tvKey.KEY_RW) :
			if(bMaple && EKC==33) return false;
			break;		
			
        case (34) :    //Page Down
        case (tvKey.KEY_FF) :	  //Page Down
        	if(bMaple && EKC==34) return false;

			break;		    	
		
        default  : 
			
        	return false;
       		break;
	}
}

/**
 * @brief		관련동영상에 포커스 있을 때 화면처리
 * @remarks		배경을 변경하여 포커스 효과 나타냄
 * @param		obj		HTML Object
 * @return	 	void
*/
function RelatedFocus(obj) {
	TRACE("RelatedFocus() ");	
	var tmpCurCnt;
	tmpCurCnt = parseInt(obj.name) + 1;
	curFocusIndex = tmpCurCnt;
	TRACE("tmpCurCnt :: "+ tmpCurCnt);
    obj.style.border = "none";
    obj.parentNode.style.backgroundImage = "url(img/sub4_box_2_s.png)";
	document.getElementById('ucc_linkbox_count').innerHTML =  tmpCurCnt  + " / " + gRelContentsListNum;
	if(gRelContentsListNum > 1){
		showHelpLayerRelatedList();	
	}else{
		showHelpLayerRelatedListNoMove();
	}	
}

/**
 * @brief		관련동영상에 포커스 벗어날 때 화면처리
 * @remarks		help layer 부분 hide
 * @param		void
 * @return	 	void
*/
function RelatedBlur() {
	if(gRelContentsListNum > 1){
		hideHelpLayerRelatedList();
	}else{
		hideHelpLayerRelatedListNoMove();
	}	
}

/**
 * @brief		검색의 Input창 show 함수
 * @remarks		input의 visiblity를 visible로 변경
 * @param		void
 * @return	 	void
*/
function showImeInput() {
	ime.setString("");
	document.getElementById("searchInput").style.visibility="visible";	
}

/**
 * @brief		'내검색어(검색어 history)'ScrollBar 초기화 함수
 * @remarks	
 * @param		void
 * @return	 	void
*/
function initSearchHistoryScrollBar() {
	// Up-arrow X and Y variables
	historyUpL = parseInt(document.getElementById("historyScrollUp").style.left);
	historyUpT = parseInt(document.getElementById("historyScrollUp").style.top);
	// Down-arrow X and Y variables
	historyDownL = parseInt(document.getElementById("historyScrollDown").style.left);
	historyDownT = parseInt(document.getElementById("historyScrollDown").style.top);
	
	historyDragL = parseInt(document.getElementById("historyScrollDrag").style.left);
	historyDragT = parseInt(document.getElementById("historyScrollDrag").style.top);
	
	histortyBarT = parseInt(document.getElementById("historyScrollBar").style.top);
    historyStartY = historyDragT;
}

/**
 * @brief		'내검색어(검색어 history)'ScrollBar show 함수
 * @remarks	
 * @param		void
 * @return	 	void
*/
function showSearchHistoryScrollBar() {
	document.getElementById("historyScrollUp").style.display="block";
	document.getElementById("historyScrollDown").style.display="block";
	document.getElementById("historyScrollBar").style.visibility="visible";
	document.getElementById("historyScrollDrag").style.visibility="visible";
}

/**
 * @brief		'내검색어(검색어 history)'ScrollBar hide 함수
 * @remarks	
 * @param		void
 * @return	 	void
*/
function hideSearchHistoryScrollBar() {
	document.getElementById("historyScrollUp").style.display="none";
	document.getElementById("historyScrollDown").style.display="none";
	document.getElementById("historyScrollBar").style.visibility="hidden";
	document.getElementById("historyScrollDrag").style.visibility="hidden";
}

/**
 * @brief		'내검색어(검색어 history)'ScrollBar의 drag버튼 이동 함수
 * @remarks	
 * @param		void
 * @return	 	void
*/
function searchHistoryScrollMoveTo() {
	document.getElementById("historyScrollDrag").style.top = historyDragT + "px";
  	document.getElementById("historyScrollUp").style.display="block";
	document.getElementById("historyScrollDown").style.display="block";
	document.getElementById("historyScrollBar").style.display="block";
	document.getElementById("historyScrollDrag").style.display="block";
}

/**
 * @brief		'내검색어(검색어 history)'ScrollBar의 drag버튼의 위치 계산 함수
 * @remarks	
 * @param		void
 * @return	 	void
*/
function searchHistoryScrollBar() {
	if (totalListPage == 1)
        historyDragT = historyStartY;
    else{
		historyDragT = historyStartY + Math.floor((currentListPage-1)/(totalListPage -1)*(historyScrollH)) - Math.floor(historyDragH/2);		
	}
	if(historyDragT < (histortyBarT)) {
		historyDragT = histortyBarT;		
    }
	if(historyDragT > (histortyBarT + historyScrollH - historyDragH)) {
		historyDragT = (histortyBarT + historyScrollH - historyDragH) - 17; // 뒤에17는 버튼 높이 
    }        
    searchHistoryScrollMoveTo();
}

/**
 * @brief		관련동영상의 ScrollBar 초기화및 show 함수
 * @remarks	
 * @param		void
 * @return	 	void
*/
function showRelatedScrollBar() {
//	alert("showRelatedScrollBar()"); 
	Related_SCROLL_REAL_WIDTH = Related_SCROLL_WIDTH - 17; //17
	RelateddragT =1;
	document.getElementById("Relateddrag").style.left = RelateddragT + "px";
	TRACE("Related_SCROLL_REAL_WIDTH" + Related_SCROLL_REAL_WIDTH);
	if(gRelContentsListNum < 2){
		document.getElementById('Relatedscrollbar').style.visibility="hidden";	
		document.getElementById('Relateddrag').style.visibility="hidden";
	} else {
		document.getElementById('Relatedscrollbar').style.visibility="visible";	
		document.getElementById('Relateddrag').style.visibility="visible";
	}
}

/**
 * @brief		관련동영상의 ScrollBar hide 함수
 * @remarks	
 * @param		void
 * @return	 	void
*/
function hideRelatedScrollBar() {
	document.getElementById('Relatedscrollbar').style.visibility="hidden";	
	document.getElementById('Relateddrag').style.visibility="hidden";
}

/**
 * @brief		관련동영상 ScrollBar의 drag버튼 이동 함수
 * @remarks		drag버튼의 위치를 좌/우 키에 따라  계산
 * @param		direction		좌/우 방향키
 * @return	 	void
*/
function RelatedScroll( direction ) {
	TRACE("RelatedScroll ::: "+ direction);
	switch( direction ) {
		case "left" : 
			RelateddragT = RelateddragT - Math.ceil( Related_SCROLL_REAL_WIDTH / gRelContentsListNum );
			if( RelateddragT < 1) {
				RelateddragT = Related_SCROLL_REAL_WIDTH;	
			}
			if( curFocusIndex == 1 ) {
				RelateddragT = 1;
			} else if (curFocusIndex == gRelContentsListNum){
				RelateddragT = Related_SCROLL_REAL_WIDTH;
			}
			
			break;
		case "right" :
			RelateddragT = RelateddragT + Math.ceil( Related_SCROLL_REAL_WIDTH / gRelContentsListNum );			
			if( RelateddragT > Related_SCROLL_REAL_WIDTH ) {
				RelateddragT = Related_SCROLL_REAL_WIDTH;					
			} else if ( curFocusIndex == 25) {
				RelateddragT = Related_SCROLL_REAL_WIDTH;
			}
			if( curFocusIndex == 1 ) {
				RelateddragT = 1;
			} else if (curFocusIndex == gRelContentsListNum ){
				RelateddragT = Related_SCROLL_REAL_WIDTH;
			}
			break;	
		case "pageup":
			RelateddragT = RelateddragT - (Math.ceil( Related_SCROLL_REAL_WIDTH / gRelContentsListNum )*3);
			if( RelateddragT < 1) {
				RelateddragT = RelateddragT +  Related_SCROLL_REAL_WIDTH;	
			}
			if( curFocusIndex == 1 ) {
				RelateddragT = 1;
			} else if (curFocusIndex == gRelContentsListNum){
				RelateddragT = Related_SCROLL_REAL_WIDTH;
			}
			
			break;
		
		case "pagedown":
			RelateddragT = RelateddragT + (Math.ceil( Related_SCROLL_REAL_WIDTH / gRelContentsListNum )*3);
			if( RelateddragT > Related_SCROLL_REAL_WIDTH ) {
				RelateddragT = RelateddragT - Related_SCROLL_REAL_WIDTH;					
			} else if ( curFocusIndex == gRelContentsListNum) {
				RelateddragT = Related_SCROLL_REAL_WIDTH;
			}
			if( curFocusIndex == 1 ) {
				RelateddragT = 1;
			} else if (curFocusIndex == 25){
				RelateddragT = Related_SCROLL_REAL_WIDTH;
			}			
			break;
		
		default:
			break;	
	}
	if(gRelContentsListNum > 1) {
		document.getElementById("Relateddrag").style.visibility="visible";
		document.getElementById("Relateddrag").style.position = "absolute";
		document.getElementById("Relateddrag").style.left = RelateddragT + "px";
	}
}

/**
 * @brief		관련동영상 Help Layer Show 함수
 * @remarks		관련동영상 Help Layer Show 함수
 * @param		void
 * @return	 	void
*/
function showHelpLayerRelatedList() {
	document.getElementById("helpLayerRelatedList").style.visibility="visible";
}

/**
 * @brief		관련동영상 Help Layer hide 함수
 * @remarks		관련동영상 Help Layer hide 함수
 * @param		void
 * @return	 	void
*/
function hideHelpLayerRelatedList() {
	document.getElementById("helpLayerRelatedList").style.visibility="hidden";
}

/**
 * @brief		관련동영상 NoMove Help Layer Show 함수
 * @remarks		관련동영상 NoMove Help Layer Show 함수
 * @param		void
 * @return	 	void
*/
function showHelpLayerRelatedListNoMove() {
	document.getElementById("helpLayerRelatedListNoMove").style.visibility="visible";
}

/**
 * @brief		관련동영상 NoMove Help Layer hide 함수
 * @remarks		관련동영상 NoMove Help Layer hide 함수
 * @param		void
 * @return	 	void
*/
function hideHelpLayerRelatedListNoMove() {
	document.getElementById("helpLayerRelatedListNoMove").style.visibility="hidden";
}

/**
 * @brief		삭제 확인 팝업의 callback 함수
 * @remarks		
 * @param		EKC	키 		obj		HTML Object
 * @return	 	void
*/
function check_popup_inputkey(EKC, obj) {
	var Idx = obj.name; 
	var tmpLastContentsID = lastContentsID;
	CommonLib.keyHandler(EKC,popupCallback);	
	switch (EKC) {
//        case (13) : 						//Enter
        case (tvKey.KEY_ENTER) : 	//Enter       
        case (tvKey.KEY_PANEL_ENTER) : 		// 패널 키 Enter
        case (tvKey.KEY_PANEL_SOURCE) : 	// 패널 키 Source
			
			if ( Idx == 1 ) { // 하나만 지우기
				selectAllCheckList(lastContentsIndex);
			} else {	// 모두 지우기 
				deleteAllCheckList(lastContentsIndex);
			}			
			lastFocusID = tmpLastContentsID;
			hideOptionPopup();
			document.getElementById(lastFocusID).focus();
        	break;
		default  : 
			
        	return false;
        	break;	
	}
}

/**
 * @brief		resource body 생성 함수
 * @remarks		위젯 내의 모든 문자를 생성(선택된 언어별로)
 * @param		void
 * @return	 	void
*/
function createResourceBody() {
	TRACE("createResourceBody()");
	createSubTitle();
	
	createHelpLayerCategoryPage();
	
	createHelpFull();
	createHelpFullBookmark();
	
	createHelpLayerRelatedList();
	createHelpLayerRelatedListNoMove()
	createHelpLayerCategory();
	
	createHelpLayerNoTimeCategory();
	createHelpLayerNoTimeCategoryPage();
	createHelpLayer();
//	createHelpLayerNoMove();
	createHelpLayerPage();
//	createHelpLayerPageNoMove();
	createHelpLayerBookmark();
	createHelpLayerPageBookmark();
	createHelpLayerIME();
	createHelpListPopup();
	createHelpLayerDetail();
	createHelpLayerDetailStop();
	createHelpLayerDetailBookmark();
	createHelpLayerDetailBookmarkStop();
	createHelpLayerFeaturedList();
	createHelpLayerPageFeaturedList();
	createHelpLayerHistoryList();
	createHelpLayerHistoryListNoMove();
	
	createPopupOneBTHelp();
	createPopupTwoBTHelp();

	TRACE("createResourceBody() end");	
}

/**
 * @brief			일반 카테고리의 동영상 재생시 Full화면의 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpFull() {
	var strTmp = "";	
	if(CM_AVSetting){
		if(CM_AVSetting.bBDPlayer){
			strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_ACTUAL+"</td><td width=10px></td><td><img src = 'img/help_back.png'></td><td width=5px></td><td>" + SID_RETURN + "</td><td width=15px></td></tr></table>";
		}else{
			strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_TOOLS+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_ACTUAL+"</td><td width=10px></td><td><img src = 'img/help_back.png'></td><td width=5px></td><td>" + SID_RETURN + "</td><td width=15px></td></tr></table>";
		}	
	}else{
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_ACTUAL+"</td><td width=10px></td><td><img src = 'img/help_back.png'></td><td width=5px></td><td>" + SID_RETURN + "</td><td width=15px></td></tr></table>";
	}	
	
	document.getElementById("helpFull").innerHTML = strTmp;	
}

/**
 * @brief			동영상 full 화면의 상단부 Help 영역
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpFullProgress() {
	var strTmp = "";
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src ='img/help_play.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_pause.png'></td><td width=5px></td><td>"+SID_PAUSE+"</td><td width=10px></td></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_ACTUAL+"</td><td width=15px></td><td><img src = 'img/help_back.png'></td><td width=5px></td><td>" + SID_RETURN + "</td></tr></table>";
	document.getElementById("helpFullProgress").innerHTML = strTmp;	
}

/**
 * @brief			'내보관함'의 동영상 재생시 Full화면의 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpFullBookmark() {
	var strTmp = "";
//	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td> <img src ='img/help_enter.png'><td width=5px></td></td><td>"+SID_ACTUAL+"</td><td><img src = 'img/help_back.png'></td><td width=5px></td><td>" + SID_RETURN + "</td><td width=15px></td></tr></table>";
	if(CM_AVSetting){
		if(CM_AVSetting.bBDPlayer){
			strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_ACTUAL+"</td><td width=10px></td><td><img src = 'img/help_back.png'></td><td width=5px></td><td>" + SID_RETURN + "</td><td width=15px></td></tr></table>";
		}else{
			strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_TOOLS+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_ACTUAL+"</td><td width=10px></td><td><img src = 'img/help_back.png'></td><td width=5px></td><td>" + SID_RETURN + "</td><td width=15px></td></tr></table>";
		}	
	}else{
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_ACTUAL+"</td><td width=10px></td><td><img src = 'img/help_back.png'></td><td width=5px></td><td>" + SID_RETURN + "</td><td width=15px></td></tr></table>";
	}	
	document.getElementById("helpFullBookmark").innerHTML = strTmp;	
}

/**
 * @brief			'관련동영상' popup의 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerRelatedList() {
	var strTmp = "";

	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_2way_g.png'></td><td width=5px></td><td>" + SID_MOVE + "</td><td width=10px></td><td> <img src ='img/help_enter_g.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back_g.png'></td><td width=5px></td><td>"+SID_RETURN+"</td></tr></table>";
	document.getElementById("helpLayerRelatedList").innerHTML = strTmp;	
}

/**
 * @brief			'관련동영상' popup의 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerRelatedListNoMove() {
	var strTmp = "";

	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_enter_g.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back_g.png'></td><td width=5px></td><td>"+SID_RETURN+"</td></tr></table>";
	document.getElementById("helpLayerRelatedListNoMove").innerHTML = strTmp;	
}

/**
 * @brief			일반 카테고리영역의 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerCategory() {
	var strTmp = "";
	if ( bDemo ) {
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_OK+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";			
	} else {
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_green.png'></td><td width=5px></td><td>" + SID_CHANGE_MODE + "</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_OK+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";		
	}	
	document.getElementById("helpLayerCategory").innerHTML = strTmp;	
}

/**
 * @brief			일반 카테고리영역의 Help 영역 작성 함수
 * @remarks	2page 이상일때 Help	
 * @param		
 * @return	 	void
*/
function createHelpLayerCategoryPage() {
	var strTmp = "";
	if ( bDemo ) {
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_HELP_PAGE_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_OK+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";			
	} else {
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_green.png'></td><td width=5px></td><td>" + SID_CHANGE_MODE + "</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_HELP_PAGE_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_OK+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";		
	}			
	document.getElementById("helpLayerCategoryPage").innerHTML = strTmp;	
}

/**
 * @brief			'추천동영상', '내보관함', '방문기록', '검색' 카테고리 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerNoTimeCategory() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_ud.png'></td><td width=5px></td><td>" + SID_MOVE + "</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_OK+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerNoTimeCategory").innerHTML = strTmp;	
}

/**
 * @brief			'추천동영상', '내보관함', '방문기록', '검색' 카테고리 Help 영역 작성 함수
 * @remarks	카테고리영역이 2page 이상일때 Help	
 * @param		
 * @return	 	void
*/
function createHelpLayerNoTimeCategoryPage() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>" + SID_HELP_PAGE_ABBR_10 + "</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_OK+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerNoTimeCategoryPage").innerHTML = strTmp;	
}

/**
 * @brief			일반 카테고리의 우측 컨텐츠 영역에 대한 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayer() {
	var strTmp = "";
	if( bDemo ) {
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0><tr><td> <img src ='img/help_yellow.png'></td><td width=5px></td><td>"+SID_SELECT+"</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";		
	} else {
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0><tr><td><img src = 'img/help_green.png'></td><td width=5px></td><td>" + SID_CHANGE_MODE + "</td><td width=10px></td><td> <img src ='img/help_yellow.png'></td><td width=5px></td><td>"+SID_SELECT+"</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";	
	}	
	document.getElementById("helpLayer").innerHTML = strTmp;	
}

/**
 * @brief			일반 카테고리의 우측 컨텐츠 영역에 대한 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerNoMove() {
	var strTmp = "";
	if( bDemo ) {
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0><tr><td> <img src ='img/help_yellow.png'></td><td width=5px></td><td>"+SID_SELECT+"</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";		
	} else {
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0><tr><td><img src = 'img/help_green.png'></td><td width=5px></td><td>" + SID_CHANGE_MODE + "</td><td width=10px></td><td> <img src ='img/help_yellow.png'></td><td width=5px></td><td>"+SID_SELECT+"</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";	
	}	
	document.getElementById("helpLayer").innerHTML = strTmp;	
}

/**
 * @brief			일반 카테고리의 우측 컨텐츠 영역에 대한 Help 영역 작성 함수
 * @remarks	2page 이상일 때의 Help	
 * @param		
 * @return	 	void
*/
function createHelpLayerPage() {
	var strTmp = "";
	if( bDemo ){
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_yellow.png'></td><td width=5px></td><td>"+SID_SELECT+"</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_HELP_PAGE_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";	
	} else {
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_green.png'></td><td width=5px></td><td>" + SID_CHANGE_MODE + "</td><td width=10px></td><td> <img src ='img/help_yellow.png'></td><td width=5px></td><td>"+SID_SELECT+"</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_HELP_PAGE_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";	
	}	
	document.getElementById("helpLayerPage").innerHTML = strTmp;	
}

/**
 * @brief			'내 보관함' Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerBookmark() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_yellow.png'></td><td width=5px></td><td>" + SID_SELECT + "</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td><img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerBookmark").innerHTML = strTmp;	
}

/**
 * @brief			'내 보관함' Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerBookmarkNoMove() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_yellow.png'></td><td width=5px></td><td>" + SID_SELECT + "</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerBookmark").innerHTML = strTmp;	
}

/**
 * @brief			'내 보관함' Help 영역 작성 함수
 * @remarks	2page 이상일때 Help	
 * @param		
 * @return	 	void
*/
function createHelpLayerPageBookmark() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_yellow.png'></td><td width=5px></td><td>" + SID_SELECT + "</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_HELP_PAGE_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerPageBookmark").innerHTML = strTmp;	
}

/**
 * @brief			검색어 입력 시 Help 영역 작성 함수
 * @remarks	Input창 Focus 시 Help	
 * @param		
 * @return	 	void
*/
function createHelpLayerIME() {
	var strTmp = "";
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_yellow.png'></td><td width=5px></td><td>" + SID_SPACE_WORD + "</td><td width=10px></td><td><img src = 'img/help_enter.png'></td><td width=5px></td><td width=5px></td><td>" + SID_SEARCH_KR_SEARCH + "</td><td width=10px></td><td><img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=5px></td><td width=15px></td></tr></table>";
	document.getElementById("searchPopupHelpLayer").innerHTML = strTmp;	
}

/**
 * @brief			Bookmark Popup Help 영역 작성 함수
 * @remarks	사용안함 (option popup으로 변경)	
 * @param		
 * @return	 	void
*/
function createHelpListPopup() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_ud.png'></td><td width=5px></td><td>" + SID_MOVE + "</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_SELECT+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td></tr></table>";
	document.getElementById("helpListPopup").innerHTML = strTmp;	
}

/**
 * @brief			동영상 재생시 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerDetail() {
	var strTmp = "";
	if(CM_AVSetting){
		if(CM_AVSetting.bBDPlayer){
			strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td> <img src ='img/help_before.png'></td><td width=5px></td><td>"+SID_HELP_PREV_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_next.png'></td><td width=5px></td><td>"+SID_NEXT+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_HELP_FULL_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";	
		}else{
			strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td> <img src ='img/help_before.png'></td><td width=5px></td><td>"+SID_HELP_PREV_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_next.png'></td><td width=5px></td><td>"+SID_NEXT+"</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_TOOLS+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_HELP_FULL_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";	
		}	
	}else{
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td> <img src ='img/help_before.png'></td><td width=5px></td><td>"+SID_HELP_PREV_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_next.png'></td><td width=5px></td><td>"+SID_NEXT+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_HELP_FULL_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";	
	}
	
	
	document.getElementById("helpLayerDetail").innerHTML = strTmp;	
}

/**
 * @brief			동영상 정지시 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerDetailStop() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_before.png'></td><td width=5px></td><td>"+SID_HELP_PREV_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_next.png'></td><td width=5px></td><td>"+SID_NEXT+"</td><td width=10px></td><td><img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";	
	document.getElementById("helpLayerDetailStop").innerHTML = strTmp;	
}

/**
 * @brief			'내 보관함' 동영상 재생시 Help 영역 작성 함수
 * @remarks	재생화면에서의 Help	
 * @param		
 * @return	 	void
*/
function createHelpLayerDetailBookmark() {
	var strTmp = "";
	if(CM_AVSetting){
		if(CM_AVSetting.bBDPlayer){
			strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td><img src ='img/help_before.png'><td width=5px></td></td><td>"+SID_HELP_PREV_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_next.png'></td><td width=5px></td><td>"+SID_NEXT+"</td><td width=10px></td></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_HELP_FULL_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
		}else{
			strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td><img src ='img/help_before.png'><td width=5px></td></td><td>"+SID_HELP_PREV_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_next.png'></td><td width=5px></td><td>"+SID_NEXT+"</td><td width=10px></td></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_TOOLS+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_HELP_FULL_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
		}	
	}else{
		strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_SKIP+"</td><td width=10px></td><td><img src ='img/help_before.png'><td width=5px></td></td><td>"+SID_HELP_PREV_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_next.png'></td><td width=5px></td><td>"+SID_NEXT+"</td><td width=10px></td></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_HELP_FULL_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	}	
	
	document.getElementById("helpLayerDetailBookmark").innerHTML = strTmp;	
}

/**
 * @brief			'내 보관함' 동영상 재생시 Help 영역 작성 함수
 * @remarks	재생화면에서의 Help	
 * @param		
 * @return	 	void
*/
function createHelpLayerDetailBookmarkStop() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td> <img src ='img/help_green.png'></td><td width=5px></td><td>"+SID_HELP_ADDTOFAVORITES_ABBR_10+"</td><td width=10px></td><td><img src ='img/help_before.png'><td width=5px></td></td><td>"+SID_HELP_PREV_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_next.png'></td><td width=5px></td><td>"+SID_NEXT+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerDetailBookmarkStop").innerHTML = strTmp;	
}

/**
 * @brief			'검색' 카테고리의 정렬방식 Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerOrderBy() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_2way.png'></td><td width=5px></td><td>" + SID_ADJUST + "</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_SELECT+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerOrderBy").innerHTML = strTmp;	
}

/**
 * @brief			'검색' 카테고리의 정렬방식 Help 영역(my history가 비어 있는경우) 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerOrderByNoHistory() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_2way.png'></td><td width=5px></td><td>" + SID_ADJUST + "</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_SELECT+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerOrderBy").innerHTML = strTmp;	
}
/**
 * @brief			'추천동영상' Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerFeaturedList() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_yellow.png'></td><td width=5px></td><td>" + SID_SELECT + "</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerFeaturedList").innerHTML = strTmp;	
}

/**
 * @brief			'추천동영상' Help 영역 작성 함수
 * @remarks	컨텐츠 리스트가 2page 이상일 때	
 * @param		
 * @return	 	void
*/
function createHelpLayerPageFeaturedList() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_yellow.png'></td><td width=5px></td><td>" + SID_SELECT + "</td><td width=10px></td><td> <img src ='img/help_tools.png'></td><td width=5px></td><td>"+SID_ADDITIONAL_FUNCTION+"</td><td width=10px></td><td><img src ='img/help_ff_rew.png'></td><td width=5px></td><td>"+SID_HELP_PAGE_ABBR_10+"</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_PLAY+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerPageFeaturedList").innerHTML = strTmp;	
}

/**
 * @brief			'내검색어' Help 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createHelpLayerHistoryList() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_tools.png'></td><td width=5px></td><td>" +SID_ADDITIONAL_FUNCTION + "</td><td width=10px></td><td> <img src ='img/help_ud.png'></td><td width=5px></td><td>"+SID_MOVE+"</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td>"+SID_SEARCH_KR_SEARCH+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerHistoryList").innerHTML = strTmp;
}

/**
 * @brief			'내검색어' Help 영역 작성 함수
 * @remarks	저장된 단어가 없는 경우	
 * @param		
 * @return	 	void
*/
function createHelpLayerHistoryListNoMove() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_tools.png'></td><td width=5px></td><td>" +SID_ADDITIONAL_FUNCTION + "</td><td width=10px></td><td> <img src ='img/help_enter.png'></td><td width=5px></td><td width=5px></td><td>"+SID_SEARCH_KR_SEARCH+"</td><td width=10px></td><td> <img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td><td width=15px></td></tr></table>";
	document.getElementById("helpLayerHistoryListNoMove").innerHTML = strTmp;
}

/**
 * @brief			Popup Help 영역 작성 함수
 * @remarks	One-Button Popup에 대한 Help 		
 * @param		
 * @return	 	void
*/
function createPopupOneBTHelp() {
	var strTmp = "";
	
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_enter.png'></td><td width=5px></td><td>" + SID_SELECT + "</td><td width=20px></td><td><img src ='img/help_back.png'></td><td width=5px></td><td width=5px></td><td>"+SID_RETURN+"</td></tr></table>";
	document.getElementById("UIPopupOneHelpLayer").innerHTML = strTmp;	
}

/**
 * @brief			Popup Help 영역 작성 함수
 * @remarks	Two-Button Popup에 대한 Help 	
 * @param		
 * @return	 	void
*/
function createPopupTwoBTHelp() {
	var strTmp = "";
	strTmp = "<table style='vertical-align:middle' border=0 cellspacing=0 cellpadding=0 ><tr><td><img src = 'img/help_2way.png'></td><td width=5px></td><td>" + SID_MOVE + "</td><td width=20px></td><td><img src = 'img/help_enter.png'></td><td width=5px></td><td width=5px></td><td>" + SID_SELECT + "</td><td width=20px></td><td><img src ='img/help_back.png'></td><td width=5px></td><td>"+SID_RETURN+"</td></tr></table>";
	document.getElementById("UIPopupTwoHelpLayer").innerHTML = strTmp;	
}

/**
 * @brief			위젯 상단 제목 영역 작성 함수
 * @remarks		
 * @param		
 * @return	 	void
*/
function createSubTitle(){
	document.getElementById("subText").innerHTML = SID_YOUTUBE_TITLE;
}

/**
 * @brief		다국어 관련 언어 설정 함수
 * @remarks		언어별로 resource 선택 
 * @param		language		언어
 * @return	 	void
*/
function selectMultiLanguage(language) {
	TRACE("selectMultiLanguage :: "+language);	
	var tempLanguageResource = new Array("ar", "bg", "cs", "da", "de", "el","en","en-GB","es","es-US","et","fa","fi","fr","fr-US","he","hr","hu","it","ko","lt","lv","nl","no","pl","pt","pt-US","ro","ru","sk","sr","sv","sl","th","tr","zh-CN","zh-HK","zh-TW");
	var bMatched = false;
	for(var i = 0; i < tempLanguageResource.length; i++){
		alert("tempLanguageResource["+i+"] == "+language)
		if(tempLanguageResource[i] == language){
			bMatched = true;
			break;			
		}else{
			bMatched = false;
		}
	}
	if(bMatched)	resourceJS = "xml/resource/"+language+".js";			
	else	resourceJS = "xml/resource/en-GB.js";			
}

/**
 * @brief		국가 설정 함수
 * @remarks		국가 값 별로 category list xml 선택
 * @param		nation 		국가값
 * @return	 	void
*/
function selectMultiCountry(nation) {
	TRACE("selectMultiCountry :: "+nation);
	switch(nation) {
		case "KR"  :		//korea
			resourceCategoryListXML = "xml/ucc_category_list_mp4.xml";
			break;
		case "US" : 		//United States
			resourceCategoryListXML = "xml/ucc_category_list_mp4_us.xml";
			break;
		case "FR"  : 		//France
			resourceCategoryListXML = "xml/ucc_category_list_mp4_fr.xml";
			break;
		case "DE" : 		//Germany
			resourceCategoryListXML = "xml/ucc_category_list_mp4_de.xml";
			break;
		case "GB"  : 		//Great Britain
			resourceCategoryListXML = "xml/ucc_category_list_mp4_uk.xml";
			break;
		case "IT"  : 		//Italy
			resourceCategoryListXML = "xml/ucc_category_list_mp4_it.xml";
			break;										
		case "ES" : 		//Spain
			resourceCategoryListXML = "xml/ucc_category_list_mp4_es.xml";
			break;
		case "CZ"  : 		//Czech
			resourceCategoryListXML = "xml/ucc_category_list_mp4_cz.xml";
			break;						
		case "PL"  : 		//Poland
			resourceCategoryListXML = "xml/ucc_category_list_mp4_pl.xml";
			break;				
		case "IE"  : 		//Ireland
			resourceCategoryListXML = "xml/ucc_category_list_mp4_ie.xml";
			break;	
		case "TW"  : 		//taiwan
			resourceCategoryListXML = "xml/ucc_category_list_mp4_tw.xml";
			break;
		case "HK"  : 		//hongkong
			resourceCategoryListXML = "xml/ucc_category_list_mp4_hk.xml";
			break;		
		case "AU"  : 		//australia
			resourceCategoryListXML = "xml/ucc_category_list_mp4_au.xml";
			break;
		case "BR"  : 		//brazil
			resourceCategoryListXML = "xml/ucc_category_list_mp4_br.xml";
			break;
		case "RU"  : 		//rusia
			resourceCategoryListXML = "xml/ucc_category_list_mp4_ru.xml";
			break;								
		default :
			resourceCategoryListXML = "xml/ucc_category_list_mp4_global.xml";
			break;		
	}
}

/**
 * @brief		Manager에서 주는 데이터 parsing 함수
 * @remarks		국가, 언어, 카테고리 값을 parsing
 * @param		void
 * @return	 	void
*/
function parsingDataFromManager() {
//	TRACE("url_query = "+decodeURI(window.location.search));
	var url_query = decodeURIComponent(window.location.search);
	var tmpStrArr = new Array();
	var tmpStrArr_detail = new Array();
	var bTmp =false;
	var nTmp =0;
	tmpStrArr = url_query.split("&");
	for(var i = 0; i<tmpStrArr.length;i++){
		 tmpStrArr_detail = tmpStrArr[i].split("=")	;
		 TRACE(tmpStrArr_detail[1]);
		 if(tmpStrArr_detail[0] == "?country"){
		 	gNation = tmpStrArr_detail[1];
			TRACE("gNation :: "+gNation);
		 }	
		if( tmpStrArr_detail[0] == "language" ){
			gLanguage = new Common.Util.Language().convertCodeToKeyword(parseInt(tmpStrArr_detail[1]));
			if(CM_AVSetting){
				CM_AVSetting.initAVSetting(gLanguage, function(){
					alert("bContentsList :: "+bContentsList);
					if( bContentsList ){
						alert("lastContentsID :: "+lastContentsID);
						document.getElementById(lastContentsID).focus();
					} else{
						alert("lastFocusID :: "+lastFocusID)
						document.getElementById(lastFocusID).focus();		
			
					}			
				});	
			}
				
			TRACE("gLanguage :: "+gLanguage);
		 }
		 if( tmpStrArr_detail[0] == "modelid" ){
		 	gModelID = tmpStrArr_detail[1];
			TRACE("gModelID :: "+gModelID);
		 }
		 if( tmpStrArr_detail[0] == "id"){
		 	gLoginID = tmpStrArr_detail[1];
//			gLoginID = gLoginID.replace(/\s/g,"");
			TRACE("gLoginID :: "+gLoginID);
		 }
		 if( tmpStrArr_detail[0] == "pw"){
		 	gLoginPW = tmpStrArr_detail[1];
			TRACE("gLoginPW :: "+gLoginPW);
		 }
		 if( tmpStrArr_detail[0] == "category"){
		 	gCategory = tmpStrArr_detail[1];
			TRACE("gCategory :: "+gCategory);
		 }
		 if( tmpStrArr_detail[0] == "area"){
		 	parsingNationFromModelID(tmpStrArr_detail[1]);
		 }	
		 if( tmpStrArr_detail[0] == "search"){
		 	goSearch = tmpStrArr_detail[1];		 	
			if(gNation == "KR" && gLanguage != "ko")
				gCategory = 10;	
			else		
				gCategory = 11;	
		 }
		 if( tmpStrArr_detail[0] == "keyword"){
		 	searchKeyword = tmpStrArr_detail[1];
			TRACE("searchKeyword :: "+searchKeyword);			
		 }		 
	}	
	if( gNation == "KR" && gLanguage != "ko") {
		gNation = "US";
	}
	
	TRACE("Nation = "+gNation+" Language = "+gLanguage+" ID = "+gLoginID+" PW = "+gLoginPW+" Category = "+gCategory+" bDemo = "+bDemo);
				
}

/**
 * @brief		검색했던 검색어 load 함수
 * @remarks		common에 존재하는 file에서 검색어 읽어옴
 * @param		void		
 * @return	 	void
*/
function loadSearchHistoryFile() {
	TRACE("loadSearchHistoryFile()");
	if( bMaple ) {
		var fs = new FileSystem();
		offWatchDog();
		if( fs.isValidCommonPath( favoriteDir ) == true) {
			fp = fs.openCommonFile( favoriteDir + "/" + SEARCH_HISTORY_SAVE, "r");
			if(fp) {
				var strLine;
				var searchText;
				
				while ((strLine=fp.readLine()) != null) {
					searchText = strLine.split("\n");
					searchText += "";
					addSearchHistoryList(searchText);					
				}
				fs.closeFile(fp);
			}else {
				TRACE(" File Open Failed!!!!!");
			}
		} else {
			TRACE(" Create Directory ucc");
			fs.createCommonDir(favoriteDir);			
		}
		onWatchDog();
	}
}

/**
 * @brief		검색했던 검색어 저장 함수
 * @remarks		common에 존재하는 file에 검색어 저장
 * @param		void		
 * @return	 	void
*/
function saveSearchHistoryFile() {
	if ( bMaple ) {
		 var fs = new FileSystem();
		 offWatchDog();
		 var searchTextAll = "";
		 
		 fp = fs.openCommonFile(favoriteDir + "/"+SEARCH_HISTORY_SAVE, "w");
		 
		 if(fp) {
		 	for(i=searchHistoryList.length -1; i>=0; i--) {
				searchTextAll += searchHistoryList[i]+""+"\n";
			}
			fp.writeAll(searchTextAll);
			fs.closeFile(fp);
		 } else {
		 	TRACE("File Open Failed!!!!!");
		 }	
		 onWatchDog();	 
	}
}

/**
 * @brief		    검색 버튼으로 focus 지정 함수
 * @remarks	검색 버튼으로 focus
 * @param		void		
 * @return	 	void
*/
function focusSearchButton() {
	bContentsList = false;	
	lastFocusID = "orderByItem5";
	document.getElementById("orderByItem5").focus();
}

/**
 * @brief		    검색 popup 생성 함수
 * @remarks	검색 popup 생성
 * @param		void		
 * @return	 	void
*/
function createSearchPopup() {
	var tmpPopup = "";
	tmpPopup = "<div id=searchPopupInput></div>"
	document.getElementById("searchPopupText").innerHTML = SID_PLEASE_ENTER_A_KEYWORD;
	document.getElementById("searchPopupName").innerHTML = SID_SEARCH_KR_SEARCH;
}

/**
 * @brief		    검색 popup show 함수
 * @remarks	검색 popup show
 * @param		void		
 * @return	 	void
*/
function showSearchPopup() {
	if(gLanguage != PL_TVMW_LANGUAGE_KOR){
		document.getElementById("searchPopupName").style.fontSize="18px";
	}else{
		document.getElementById("searchPopupName").style.fontSize="16px";
	}
	document.getElementById("searchPopup").style.visibility = "visible";
	document.getElementById("searchPopupLineUp").style.visibility = "visible";
	document.getElementById("searchPopupLineDown").style.visibility = "visible";	
	
	hideAllHelpLayer();	
	showImeInput();
}

/**
 * @brief		    검색 popup hide 함수
 * @remarks	검색 popup hide
 * @param		void		
 * @return	 	void
*/
function hideSearchPopup() {
	document.getElementById("searchInput").style.visibility = "hidden";
	document.getElementById("searchPopup").style.visibility = "hidden";
	document.getElementById("searchPopupLineUp").style.visibility = "hidden";
	document.getElementById("searchPopupLineDown").style.visibility = "hidden";	
}

/**
 * @brief		modelID로 국가값 확인 함수
 * @remarks		국가별 date 표현위해 국판, 구주, 미주, 성장, 브라질향 구분
 * @param		modelID		모델ID		
 * @return	 	void
*/
function parsingNationFromModelID(pArea) {
	TRACE("parsingNationFromModelID :: "+pArea);
	
	switch(pArea){
		case("KOR"):
			gDate = "ko";
		break;
		case("USA"):
			gDate = "us";
		break;
		
		case("BRA"):	
			gDate = "br";
		break;
		
		case("PANEURO"):
			gDate = "eu";
		break;
		
		default:
			gDate = "us";
		break;
	}	
	TRACE("gDate = "+gDate);
}

/**
 * @brief		국가별 date 표현 변환 함수
 * @remarks		국판, 구주, 미주, 성장, 브라질향 별 date 표현 변환
 * @param		strPupdate		유튜브 동영상 published Date(Feb/02/2009)
 * @return	 	tmpPupdate		변환된 date값
*/
function transferPupdateExpression( strPupdate ) {
	var dateObj = new Date(strPupdate);
	var tmpYear =dateObj.getFullYear();
	var tmpPupdate ="";
	var tmpMonth=(dateObj.getMonth() + 1);
	if ( tmpMonth < 10) {
		tmpMonth = "0"+tmpMonth+"";
	}		
	var tmpDate=dateObj.getDate();
	
	if( tmpDate <10 ){
		tmpDate = "0"+tmpDate+"";			
	}
	if( gDate == "eu" || gDate == "br" ) {
		tmpPupdate = tmpDate + "/" + tmpMonth + "/" + tmpYear + "";		
	} else if(gDate == "us"){
		tmpPupdate = tmpMonth + "/" + tmpDate + "/" + tmpYear + "";		
	}else {
		tmpPupdate = tmpYear + "/" + tmpMonth + "/" + tmpDate + "";
	}
	return tmpPupdate;
}

/**
 * @brief		북마크 추가 팝업
 * @remarks		즐겨찾기, TV보관함 선택창
 * @param		void
 * @return	 	void
*/
function createSelectBookmark() {
	TRACE("createSelectBookmark() ")
	var tmpID = selBookmarkID;
	
	document.getElementById("PopupTitle").innerHTML = SID_FAVORITE_TITLE_ABBR_10;
	document.getElementById("FavoritesButton").innerHTML = "<a id="+tmpID+ 0 +" class ='favoritesEnable' href=javascript: onkeydown=selectBookmark_inputKey(this); onfocus= selectBookmarkFocus(this); onblur=selectBookmarkBlur(this); name=0 >"+SID_FAVORITES+"</a>";		
	
	document.getElementById("TVLibraryButton").innerHTML = "<a id="+tmpID+ 1 +" href=javascript: onkeydown=selectBookmark_inputKey(this); onfocus= selectBookmarkFocus(this); onblur=selectBookmarkBlur(this); name=1>"+SID_CATEGORY_TVBOOKMARK+"</a>";
	document.getElementById("FavoritesExplain").innerHTML = "<table cellspacing=0 cellpadding=0 border=0><td width=390px height= 90px style='padding-left:10px; font-size: 16px; color:#FFFFFF; line-height: 28px;'>"+SID_FAVORITE_EXPLAIN_ABBR_10+"</td></table>";
	document.getElementById("TVLibraryExplain").innerHTML = "<table cellspacing=0 cellpadding=0 border=0><td width=390px height= 90px style='padding-left:10px; font-size: 16px; color:#FFFFFF; line-height: 28px;'>"+SID_TVBOOKMARK_EXPLAIN+"</td></table>";	
	
	showSelectBookmark();
}

/**
 * @brief		북마크 추가 팝업
 * @remarks		즐겨찾기, TV보관함 보여줌
 * @param		void
 * @return	 	void
*/
function showSelectBookmark() {
	TRACE("showSelectBookmark()");
	locateFocus = selBookmarkID;
	hideAllHelpLayer();
	document.getElementById("SelectBookmarkPopupDiv").style.visibility="visible";
	if(!bLogin) {
		lastSelBookmarkID = "selButton1";
		document.getElementById("selButton1").focus();
	}else {
		lastSelBookmarkID = "selButton0";
		document.getElementById("selButton0").focus();	
	}		
	selBookmarkPopupTimer(TIMER_SET, 60);
	bShowSelPopup = true;
}

/**
 * @brief		북마크 추가 팝업
 * @remarks		즐겨찾기, TV보관함 숨김
 * @param		void
 * @return	 	void
*/
function hideSelectBookmark() {
	document.getElementById("SelectBookmarkPopupDiv").style.visibility="hidden";
	bShowSelPopup = false;
	if( bContentsList )
		document.getElementById(lastContentsID).focus();
	else
		document.getElementById(lastFocusID).focus();		
}	

/**
 * @brief		북마크 추가 팝업 키처리 함수
 * @remarks		
 * @param		obj	HTML object
 * @return	 	void
*/
function selectBookmark_inputKey(obj) {
//	var ie = (document.all) ? 1:0
//    if (ie) { var EKC = event.keyCode;}
	var EKC = event.keyCode;
	var Idx = obj.name; //해당 Index 가져오기..
	var tmpPopupID;	
	TRACE("key num : " + EKC);
	CommonLib.keyHandler(EKC,popupCallback);	
	selBookmarkPopupTimer(TIMER_RESET);		//버튼 입력이 들어올경우 popup 지속시간 timer reset
	 switch (EKC) {
//        case (38) :    	// pc up key
        case (tvKey.KEY_UP) : 	// remocon up key
		case (tvKey.KEY_WHEELUP): 		// remocon wheel left
		case (tvKey.KEY_PANEL_CH_UP) :			// 패털키 UP
			if(bMaple && EKC==38) return false;
            if(Idx == 0) {
				Idx = 1;
				tmpPopupID = selBookmarkID +Idx;
				document.getElementById(tmpPopupID).focus();
			}else{
				if(bLogin){
					Idx--;
					tmpPopupID = selBookmarkID +Idx;	
					document.getElementById(tmpPopupID).focus();
				}				
			}	
			lastSelBookmarkID = tmpPopupID;	
        break;
        
//        case (40) :    	//down 화살표..
        case (tvKey.KEY_DOWN) :
		case (tvKey.KEY_WHEELDOWN): 	// remocon wheel right
		case (tvKey.KEY_PANEL_CH_DOWN):		// 패널키 Down 
			if(bMaple && EKC==40) return false;
			if(Idx == 1) {
				if( bLogin) {
					Idx = 0;
					tmpPopupID = selBookmarkID +Idx;	
					document.getElementById(tmpPopupID).focus();
				}				
			}else{
				Idx++;
				tmpPopupID = selBookmarkID +Idx;
				document.getElementById(tmpPopupID).focus();
			}
			lastSelBookmarkID = tmpPopupID;			
		break;		
		
//		case (13) : 							// Enter
        case (tvKey.KEY_ENTER) : 	// Enter       
        case (tvKey.KEY_PANEL_ENTER) : 		// 패널 키 Enter
        case (tvKey.KEY_PANEL_SOURCE) : 	// 패널 키 Source
            if(bMaple && EKC==13) return false;  
			if (gPopupInstance != null)  {
				clearTimeout(gPopupInstance);
   			}			 
			hideSelectBookmark();
			if(Idx==0){
				addBookmark(); 	
			} else {
				addTvBookmark(); 	
			}
			
		break;	
		
        case (tvKey.KEY_RETURN) : 	// ESC
        case (tvKey.KEY_PANEL_MENU): 		// 패널 키 ESC
        case (tvKey.KEY_EXIT):		 	//Exit Key       
	        blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다        
	        TRACE("Focus to lastFocusID = " + lastFocusID);
			if (gPopupInstance != null)  {
				clearTimeout(gPopupInstance);
   			}
			hideSelectBookmark();			
       		break;

		default: 			
        	return false;
        	break;	
	}          
}

/**
 * @brief		북마크 추가 팝업에 focus가 있을 때 화면 처리
 * @remarks		버튼 바탕에 이미지 변경하여 원래대로 변경
 * @param		obj	HTML object
 * @return	 	void
*/
function selectBookmarkFocus(obj) {
	obj.parentNode.style.background ="url(img/gallery_button_sel.png)";	
}

/**
 * @brief		북마크 추가 팝업에 focus가 변경되었을 때 화면 처리
 * @remarks		버튼 바탕에 이미지 변경하여 focus 효과
 * @param		obj	HTML object
 * @return	 	void
*/
function selectBookmarkBlur(obj) {
	obj.parentNode.style.background ="url(img/gallery_button_nor.png)";
}

/**
 * @brief		북마크 추가 팝업 지속시간 
 * @remarks		각 mode 별로 resetCloseTimer() 호출
 * @param		mode : timer를 set할것인지 reset할 것인지		timer: 지속시간
 * @return	 	void
*/
function selBookmarkPopupTimer(mode, timer) {
	TRACE("selBookmarkPopupTimer("+mode +"," + timer+")");
	switch (mode) {
		case TIMER_SET :
			if (timer != -1) {
				gPopupTimer = eval(timer) * 1000;
				resetCloseTimer();
			}
			else {
				gPopupTimer = false;
			}
			break;
		case TIMER_RESET :
			if (gPopupTimer != false)
				resetCloseTimer ();
			break;
		default:
			break;
	}
	TRACE("selBookmarkPopupTimer("+mode +"," + timer+") Ends.");
}

/**
 * @brief		북마크 추가 팝업 timer 함수
 * @remarks		정해진 time만큼 wait하다 popup hide함수 호출
 * @param		void
 * @return	 	void
*/
function resetCloseTimer() {
	if (gPopupInstance != null)  {
		clearTimeout(gPopupInstance);
    }
	gPopupInstance = setTimeout(function(){
		hideSelectBookmark();
	}, gPopupTimer);
}

/**
 * @brief		String wrapping
 * @remarks		In case that language is thai, wrap contents with span to change letter space to 0px
 * @param		
 * @return	 	
*/
function adaptString(pStrContents) {
	var tStrContents = "";
	// If language is thai, set letter space to 0px
	if (gLanguage == PL_TVMW_LANGUAGE_THA) {
		tStrContents = "<font style = 'letter-spacing : 0px;'>" + pStrContents + "</font>";
	}
	else {
		tStrContents = pStrContents;
	}
	return tStrContents;
}

/**
 * @brief		String wrapping
 * @remarks		In case that language is thai, wrap contents with span to change letter space to 0px
 * @param		
 * @return	 	
*/
function letterSpacing_fix(){
	if (gLanguage == PL_TVMW_LANGUAGE_THA){
		var headID = document.getElementsByTagName("head")[0];      
		var cssNode = document.createElement('link');
		cssNode.type = 'text/css';
		cssNode.rel = 'stylesheet';
		cssNode.href = 'letterSpacing.css';
		headID.appendChild(cssNode);	
	}else {
		return;
	}	
}


function contentsListObj (tContentsList, tContentsImg, tDetailInfoListXmlURL, tContentsTime, tContentsTimeUpdate, tVideoGuid, tPlayURL, tPlayURL264,	
		tPlayerType, tDescription, tDuration, tViewcount, tAverage, tKeyWords) {
		TRACE("tContentsList :: "+tContentsList)				
		this.contentsList = tContentsList;
        this.contentsImg = tContentsImg;
        this.detailInfoListXmlURL = tDetailInfoListXmlURL;			
		this.contentsTime = tContentsTime;	
		this.contentsTimeUpdate = tContentsTimeUpdate;
		this.videoGuid = tVideoGuid;		
		this.playURL = tPlayURL;		
		this.playURL264= tPlayURL264;	
		this.playerType = tPlayerType;
		this.description = tDescription;
		this.duration = tDuration;
		this.viewcount = tViewcount;
		this.average = tAverage;
		this.keyWords = tKeyWords;
}
